'use strict';

var St = require('crypto');
var We = require('fs');
var path = require('path');
var promises = require('fs/promises');
var Ci = require('tty');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var St__default = /*#__PURE__*/_interopDefault(St);
var We__default = /*#__PURE__*/_interopDefault(We);
var Ci__default = /*#__PURE__*/_interopDefault(Ci);

function Tr(){if(typeof self<"u")return self;if(typeof window<"u")return window;if(typeof global<"u")return global;if(typeof globalThis<"u")return globalThis;throw new Error("unable to locate global object")}function X(){let e=Tr();return e._zeedGlobal==null&&(e._zeedGlobal={}),e._zeedGlobal}function Lr(e){return e===!0||e==="true"||e==="1"||typeof e=="number"&&e!==0?e="*":e===!1||e==="false"||e===0||e==="0"||e==null||e==="null"||e==="undefined"?e="":e=String(e),e}function Ar(){return Lr(typeof process<"u"?process.env.ZEED??process.env.DEBUG:typeof localStorage<"u"?localStorage.zeed??localStorage.debug:"*")}function j(e=Ar()){let t,n=[],r=[];if(!e)t=function(o){return !1};else if(e==="*")t=function(o){return !0};else {let o,i=e.split(/[\s,]+/),a=i.length;for(o=0;o<a;o++){if(!i[o])continue;let s=i[o].replace(/\*/g,".*?");s[0]==="-"?n.push(new RegExp(`^${s.substr(1)}$`)):r.push(new RegExp(`^${s}$`));}t=function(s){if(n.length===0&&r.length===0)return !0;let u,c;for(u=0,c=n.length;u<c;u++)if(n[u].test(s))return !1;for(u=0,c=r.length;u<c;u++)if(r[u].test(s))return !0;return !1};}return t.accept=r,t.reject=n,t.filter=e,t}function vr(){return typeof process<"u"?process.env.ZEED_LEVEL??process.env.LEVEL??process.env.DEBUG_LEVEL:typeof localStorage<"u"?localStorage.zeed_level??localStorage.level??localStorage.debug_level:void 0}function Ke(e){if(e===!1)return ee;if(typeof e=="number")return e;if(typeof e=="string"){let t=Ot[e.toLocaleLowerCase().trim()];if(t!=null)return t}return W}function z(e=vr()){let t=Ke(e);return n=>n>=t}function we(e={}){let{level:t=void 0,filter:n=void 0}=e,r=j(n),o=z(t);return i=>{if(!o(i.level)||!r(i.name))return;let a=i.name?`[${i.name}]`:"";switch(i.level){case O:console.info(`I|*   ${a}`,...i.messages);break;case B:console.warn(`W|**  ${a}`,...i.messages);break;case $:console.error(`E|*** ${a}`,...i.messages);break;default:console.debug(`D|    ${a}`,...i.messages);break}}}var W=-1,J=0,O=1,B=2,$=3,Te=4,ee=9007199254740991,Ot={"*":W,a:W,all:W,d:J,dbg:J,debug:J,i:O,inf:O,info:O,w:B,warn:B,warning:B,e:$,err:$,error:$,fatal:Te,off:ee,"-":ee};function _t(e=""){let t=[we()],n=u=>!0,r=!1,o=a,i=!1;function a(u="",c){let p=Ke(c??W);function l(g,m){return p<=g?m:()=>{}}let f=l(J,(...g)=>{d({name:u,messages:g,level:J});});f.label=u,f.extend=function(g){return o(u?`${u}:${g}`:g)};let d=g=>{if(n(u))for(let m of t)m&&m(g);};return f.debug=l(J,(...g)=>{d({name:u,messages:g,level:J});}),f.info=l(O,(...g)=>{d({name:u,messages:g,level:O});}),f.warn=l(B,(...g)=>{d({name:u,messages:g,level:B});}),f.error=l($,(...g)=>{d({name:u,messages:g,level:$});}),f.fatal=l(Te,(...g)=>{throw d({name:u,messages:g,level:Te}),new Error(`${g.map(String).join(" ")}`)}),f.assert=l(Te,(g,...m)=>{(g==null||typeof g=="number"&&isNaN(g)||!g)&&f.fatal(...m);}),f}function s(u="",c){let p=o(u,c);return i&&p.debug(`+++ init of logger "${u}" on level "${p.level}".`),p}return s.registerHandler=function(u){t.push(u);},s.setFilter=function(u){n=j(u);},s.setLock=(u=!0)=>r=u,s.setDebug=(u=!0)=>i=u,s.setHandlers=function(u=[]){o!==a&&(o=a),!r&&(t=[...u].filter(c=>typeof c=="function"));},s.level=W,s.setLogLevel=function(u=W){r||(s.level=u);},s.setFactory=function(u){r||(o=u);},s}var V;function Ye(e){let t=_t();return e?e(t):t.setHandlers([we()]),t}function Qe(e){if(V==null)try{let t=X();t!=null?t?.logger==null?(V=Ye(e),t.logger=V):V=t.logger:V=Ye(e);}catch{V=Ye(e);}return V}function jt(){if(V!=null)return V;try{let e=X();if(e?.logger!=null)return e.logger}catch{}}function R(e,t){return Qe()(e,t)}function Er(...e){throw jt()?.("assert")?.fatal(...e),new Error(`${e.map(String).join(" ")}`)}function Ur(e,...t){(e==null||typeof e=="number"&&isNaN(e)||!e)&&Er(...t);}function Nt(e,...t){Ur(e,...t);}var Cr=(e,t)=>t instanceof Object&&!Array.isArray(t)?Object.keys(t).sort().reduce((n,r)=>(n[r]=t[r],n),{}):t;function qi(e,t=void 0){return JSON.stringify(e,Cr,t)}function Fr(e,t){let n=[],r=[];return t==null&&(t=function(o,i){return n[0]===i?"[Circular ~]":`[Circular ~.${r.slice(0,n.indexOf(i)).join(".")}]`}),function(o,i){if(n.length>0){let a=n.indexOf(this);~a?n.splice(a+1):n.push(this),~a?r.splice(a,1/0,o):r.push(o),~n.indexOf(i)&&(i=t?.call(this,o,i));}else n.push(i);try{return e==null?i:e.call(this,o,i)}catch{}return String(i)}}function k(e,t,n,r){return JSON.stringify(e,Fr(t??void 0,r),n??void 0)}var Ji=k;function Dr(e){let t=unescape(encodeURIComponent(e)),n=t.length,r=new Uint8Array(n);for(let o=0;o<n;o++)r[o]=t.codePointAt(o)||0;return r}function Sr(e){let t=e.length,n="",r=0;for(;t>0;){let o=t<1e4?t:1e4,i=e.subarray(r,r+o);r+=o,n+=String.fromCodePoint.apply(null,i),t-=o;}return decodeURIComponent(escape(n))}var Le;function Vt(e){if(Le==null&&(Le=Dr,typeof TextEncoder<"u")){let t=new TextEncoder;Le=n=>t.encode(n);}return Le(e.normalize("NFC"))}var Ae;function Ht(e){if(Ae==null&&(Ae=Sr,typeof TextDecoder<"u")){let t=new TextDecoder("utf-8",{ignoreBOM:!0});Ae=n=>t.decode(n);}return Ae(e).normalize("NFC")}function U(e){return e instanceof ArrayBuffer?new Uint8Array(e):typeof e=="string"?Vt(e):e.length?new Uint8Array(e):e}function Yi(...e){let t=0,n=e.flat(1).map(i=>{let a=U(i);return t+=a.length,a}),r=new Uint8Array(t),o=0;for(let i of n)r.set(i,o),o+=i.length;return r}function Gt(e){if(typeof Buffer<"u")return Buffer.from(U(e)).toString("hex");let t="0123456789abcdef",n="";for(let r of [...U(e)])n+=t[r>>4]+t[r&15];return n}function zt(e){return Uint8Array.from(e.match(/.{1,2}/g).map(t=>parseInt(t,16)))}function fe(e,t=!1){let n=U(e),r="";if(typeof Buffer<"u")r=Buffer.from(n).toString("base64");else {let o="";for(let i=0;i<n.byteLength;i++)o+=String.fromCharCode(n[i]);r=btoa(o);}return t?r.replaceAll("=",""):r}function Qi(e){let t=U(e);if(typeof Buffer<"u")return Buffer.from(t).toString("base64url").replaceAll("=","");let n="";for(let r=0;r<t.byteLength;r++)n+=String.fromCharCode(t[r]);return btoa(n).replaceAll("+","-").replaceAll("/","_").replaceAll("=","")}function ve(e){if(e=e.replaceAll("-","+").replaceAll("_","/"),typeof Buffer<"u"){let r=Buffer.from(e,"base64");return new Uint8Array(r.buffer,r.byteOffset,r.byteLength)}let t=atob(e),n=new Uint8Array(t.length);for(let r=0;r<t.length;r++)n[r]=t.charCodeAt(r);return n}function Xi(e){return Ht(ve(e))}function Wt(e,t){if(e.byteLength!==t.byteLength)return !1;let n=U(e),r=U(t);for(let o=0;o<n.length;o++)if(n[o]!==r[o])return !1;return !0}function Xe(e){return Vt(k(e))}function et(e){return JSON.parse(Ht(e))}function qt(e,t){if(typeof e!="string")if(e instanceof ArrayBuffer&&e.byteLength!==void 0)e=String.fromCharCode.apply(String,[].slice.call(new Uint8Array(e)));else if(Array.isArray(e))e=String.fromCharCode.apply(String,e);else if(e.constructor===Uint8Array)e=String.fromCharCode.apply(String,[].slice.call(e));else return !1;t=t||16;let n=[],r="0123456789ABCDEF";for(let o=0;o<e.length;o+=t){let i=e.slice(o,Math.min(o+t,e.length)),a=`0000${o.toString(16)}`.slice(-4),s=i.split("").map(c=>{let p=c.charCodeAt(0);return ` ${r[(240&p)>>4]}${r[15&p]}`}).join("");s+="   ".repeat(t-i.length);let u=i.replace(/[\x00-\x1F\x20\x7F-\xA0\xAD]/g,".");u+=" ".repeat(t-i.length),n.push(`${a} ${s}  ${u}`);}return n.join(`
`)}var te;function Zt(){return te===void 0&&(te=(typeof TextDecoder>"u"?null:new TextDecoder("utf-8",{fatal:!0,ignoreBOM:!0}))??null,te&&te.decode(new Uint8Array).length===1&&(te=null)),te}var Yt="Unexpected end of array",Qt="Integer out of Range",tt=class{constructor(t){this.arr=t,this.pos=0;}};function Fe(e){return new tt(e)}function nt(e,t){let n=ge(e.arr.buffer,e.pos+e.arr.byteOffset,t);return e.pos+=t,n}function ne(e){let t=0,n=1,r=e.arr.length;for(;e.pos<r;){let o=e.arr[e.pos++];if(t=t+(o&127)*n,n*=128,o<128)return t;if(t>Number.MAX_SAFE_INTEGER)throw new Error(Qt)}throw new Error(Yt)}function De(e){return nt(e,ne(e))}function de(e){return e.arr[e.pos++]}function Xt(e){let t=e.arr[e.pos]+(e.arr[e.pos+1]<<8);return e.pos+=2,t}function en(e){let t=e.arr[e.pos]+(e.arr[e.pos+1]<<8)+(e.arr[e.pos+2]<<16)+(e.arr[e.pos+3]<<24)>>>0;return e.pos+=4,t}function rt(e){let t=e.arr[e.pos++],n=t&63,r=64,o=(t&64)>0?-1:1;if(!(t&128))return o*n;let i=e.arr.length;for(;e.pos<i;){if(t=e.arr[e.pos++],n=n+(t&127)*r,r*=128,t<128)return o*n;if(n>Number.MAX_SAFE_INTEGER)throw new Error(Qt)}throw new Error(Yt)}function kr(e){let t=ne(e);if(t===0)return "";{let n=String.fromCodePoint(de(e));if(--t<100)for(;t--;)n+=String.fromCodePoint(de(e));else for(;t>0;){let r=t<1e4?t:1e4,o=e.arr.subarray(e.pos,e.pos+r);e.pos+=r,n+=String.fromCodePoint.apply(null,o),t-=r;}return decodeURIComponent(escape(n))}}function Ce(e){let t=Zt();return t?t.decode(De(e)):kr(e)}function ot(e,t){let n=new DataView(e.arr.buffer,e.arr.byteOffset+e.pos,t);return e.pos+=t,n}function it(e){return ot(e,4).getFloat32(0,!1)}function Ir(e){return ot(e,8).getFloat64(0,!1)}function Mr(e){return ot(e,8).getBigInt64(0,!1)}var Br=[e=>{},e=>null,rt,it,Ir,Mr,e=>!1,e=>!0,Ce,e=>{let t=ne(e),n={};for(let r=0;r<t;r++){let o=Ce(e);n[o]=re(e);}return n},e=>{let t=ne(e),n=[];for(let r=0;r<t;r++)n.push(re(e));return n},De];function re(e){return Br[127-de(e)](e)}function ge(e,t,n){return new Uint8Array(e,t,n)}var st=class{constructor(){this.cpos=0,this.cbuf=new Uint8Array(100),this.bufs=[];}};function Re(){return new st}function at(e){let t=e.cpos;for(let n=0;n<e.bufs.length;n++)t+=e.bufs[n].length;return t}function ke(e){let t=new Uint8Array(at(e)),n=0;for(let r=0;r<e.bufs.length;r++){let o=e.bufs[r];t.set(o,n),n+=o.length;}return t.set(ge(e.cbuf.buffer,0,e.cpos),n),t}function $r(e,t){let n=e.cbuf.length;n-e.cpos<t&&(e.bufs.push(ge(e.cbuf.buffer,0,e.cpos)),e.cbuf=new Uint8Array(Math.max(n,t)*2),e.cpos=0);}function F(e,t){let n=e.cbuf.length;e.cpos===n&&(e.bufs.push(e.cbuf),e.cbuf=new Uint8Array(n*2),e.cpos=0),e.cbuf[e.cpos++]=t;}var rn=F;function on(e,t){F(e,t&255),F(e,t>>>8&255);}function sn(e,t){for(let n=0;n<4;n++)F(e,t&255),t>>>=8;}function Z(e,t){for(;t>127;)F(e,128|127&t),t=Math.floor(t/128);F(e,127&t);}function Or(e){return e!==0?e<0:1/e<0}function ut(e,t){let n=Or(t);for(n&&(t=-t),F(e,(t>63?128:0)|(n?64:0)|63&t),t=Math.floor(t/64);t>0;)F(e,(t>127?128:0)|127&t),t=Math.floor(t/128);}function Ie(e,t){let n=e.cbuf.length,r=e.cpos,o=Math.min(n-r,t.length),i=t.length-o;e.cbuf.set(t.subarray(0,o),r),e.cpos+=o,i>0&&(e.bufs.push(e.cbuf),e.cbuf=new Uint8Array(Math.max(n*2,i)),e.cbuf.set(t.subarray(o)),e.cpos=i);}function Me(e,t){Z(e,t.byteLength),Ie(e,t);}function jr(e,t){let n=unescape(encodeURIComponent(t)),r=n.length;Z(e,r);for(let o=0;o<r;o++)F(e,n.codePointAt(o));}function Pe(e,t){return jr(e,t)}function ct(e,t){$r(e,t);let n=new DataView(e.cbuf.buffer,e.cpos,t);return e.cpos+=t,n}function lt(e,t){return ct(e,4).setFloat32(0,t,!1)}function Nr(e,t){return ct(e,8).setFloat64(0,t,!1)}function Vr(e,t){return ct(e,8).setBigInt64(0,t,!1)}var Se;function Hr(e){return Se==null&&(Se=new DataView(new ArrayBuffer(4))),Se.setFloat32(0,e),Se.getFloat32(0)===e}function ie(e,t){switch(typeof t){case"string":F(e,119),Pe(e,t);break;case"number":Number.isInteger(t)&&Math.abs(t)<=2147483647?(F(e,125),ut(e,t)):Hr(t)?(F(e,124),lt(e,t)):(F(e,123),Nr(e,t));break;case"bigint":F(e,122),Vr(e,t);break;case"object":if(t===null)F(e,126);else if(Array.isArray(t)){F(e,117),Z(e,t.length);for(let n=0;n<t.length;n++)ie(e,t[n]);}else if(t instanceof Uint8Array)F(e,116),Me(e,t);else {F(e,118);let n=Object.keys(t);Z(e,n.length);for(let r=0;r<n.length;r++){let o=n[r];Pe(e,o),ie(e,t[o]);}}break;case"boolean":F(e,t?120:121);break;default:F(e,127);}}var an=class{async encode(t){let n=Re();return ie(n,t),ke(n)}async decode(t){return re(Fe(U(t)))}};function ys(e){let t=Re();return ie(t,e),ke(t)}function hs(e){return re(Fe(U(e)))}function xs(e){let t=Re();return e!=null&&Ie(t,U(e)),{writeBytes:(n,r)=>{let o=U(n);Nt(!(r!=null&&o.length!==r),`Expected ${r} bytes, got ${o.length}`),Ie(t,o);},writeBytesVar:n=>Me(t,U(n)),writeUintVar:n=>Z(t,n),writeUint8:n=>rn(t,n),writeUint16:n=>on(t,n),writeUint32:n=>sn(t,n),writeIntVar:n=>ut(t,n),writeFloat:n=>lt(t,n),writeStringVar:n=>Pe(t,n),write:n=>ie(t,n),getUint8Array:()=>ke(t),getLength:()=>at(t)}}function bs(e){let t=Fe(U(e));return {readBytes:n=>nt(t,n),readBytesVar:()=>De(t),readUintVar:()=>ne(t),readUint8:()=>de(t),readUint16:()=>Xt(t),readUint32:()=>en(t),readIntVar:()=>rt(t),readFloat:()=>it(t),readStringVar:()=>Ce(t),read:()=>re(t),getOffset:()=>t.pos||0}}function ws(e=0){return {setBit:(t,n=!0)=>n?e|=1<<t:e&=~(1<<t),unsetBit:t=>e&=1<<t,toggleBit:t=>e^=1<<t,getBit:t=>(e&1<<t)!==0,getValue:()=>e}}async function Gr(e){return await e.arrayBuffer()}async function Ts(e){let t=await Gr(e);if(t!=null)return U(t)}function se(e=16){let t=new Uint8Array(e);if(typeof crypto<"u"&&crypto.getRandomValues)crypto.getRandomValues(t);else for(let n=0;n<e;n++)t[n]=Math.floor(Math.random()*256);return t}var cn="SHA-256",ft="AES-GCM",un="PBKDF2",zr=1e5;async function vs(e,t=cn){return U(await crypto.subtle.digest(t,U(e)))}async function Es(e,t={}){let n=U(e),r=await crypto.subtle.importKey("raw",n,un,!1,["deriveKey"]);return await crypto.subtle.deriveKey({name:un,salt:t.salt?U(t.salt):new Uint8Array(0),iterations:t.iterations??zr,hash:cn},r,{name:ft,length:256},!0,["encrypt","decrypt"])}function ln(){return new Uint8Array([1,1])}async function fn(e,t){let n=ln(),r=se(12),o=await crypto.subtle.encrypt({name:ft,iv:r},t,e),i=new Uint8Array(o),a=n.length+r.length+i.length,s=new Uint8Array(a),u=0;return s.set(n,u),u+=n.length,s.set(r,u),u+=r.length,s.set(i,u),s}async function pn(e,t){let n=e.subarray(0,2);if(!Wt(n,ln()))return Promise.reject(new Error(`Unknown magic ${n}`));let r=e.subarray(2,2+12),o=e.subarray(2+12,e.length),i=await crypto.subtle.decrypt({name:ft,iv:r},t,o);return new Uint8Array(i)}function Wr(){return crypto.getRandomValues(new Uint32Array(1))[0]/4294967295}function S(){return typeof crypto<"u"?Wr():Math.random()}function Cs(e=.25){return S()<e}function Fs(e=100,t=0){return t+Math.floor(S()*(e-t))}function Ds(e=100,t=0){return t+S()*(e-t)}function Ss(e,t,n){return Math.max(e,Math.min(n,t))}function qr(e){return e.reduce((t,n)=>t+n,0)}function Ps(e){return qr(e)/e.length}function Rs(e){return !/^1?$|^(11+?)\1+$/.test("1".repeat(e))}function ks(e){for(let t=2;t<e;t++)if(e%t===0)return !1;return e>1}var pt=6;function Is(e=0,t=1,n){pt=((n??pt)*9301+49297)%233280;let r=pt/233280;return t+r*(e-t)}function Jr(e=""){let[t="",n="asc"]=e.split(" ");return n=n.toLowerCase(),{field:t,orderby:n,asc:n!=="desc",desc:n==="desc"}}function Bs(e,t=!0){return `${e} ${t?"asc":"desc"}`}function dt(e,t,n=!0){let r=e||0,o=t||0;return r>o?n?1:-1:r<o?n?-1:1:0}function $s(e,...t){if(t.length>0){let n=t.map(Jr),r=Array.from(e);return r.sort((o,i)=>{for(let{field:a,asc:s}of n){let u=dt(o[a],i[a],s);if(u!==0)return u}return 0}),r}return e}function gt(e){return e.filter((t,n)=>e.indexOf(t)===n)}function Zr(e,t){return gt(e.filter(n=>!t.includes(n)))}function Kr(...e){return gt(e.reduce((t=[],n)=>t.concat(n),[]))}function ae(...e){return e.flat(1/0)}function Yr(e,t){return gt(e).filter(n=>t.includes(n))}function Ns(e,t){return Zr(Kr(e,t),Yr(e,t))}function dn(e,t){if(e&&Array.isArray(e)){let n;for(;(n=e.indexOf(t))!==-1;)e.splice(n,1);return e}return []}function Vs(e,t){return e.includes(t)||e.push(t),e}function mt(e,t){return e.splice(0,e.length,...e.filter(t)),e}function Hs(e,t){let n=e.findIndex(r=>r===t);return n>=0?e.splice(n,1):e.push(t),e}function Gs(e){return e.splice(0,e.length),e}function Qr(e,t=dt){return Array.from(e).sort(t)}function zs(e){return Qr(e,(t,n)=>t-n)}function Xr(e,t){return e.length===t.length&&e.every((n,r)=>n===t[r])}function gn(e){return e.sort(()=>S()>.5?1:-1),e}function Ws(e){return gn(Array.from(e))}function qs(e){for(;e.length>1;){let t=Array.from(e);if(gn(t),!Xr(e,t))return t}return e}function Js(e){return e[Math.floor(S()*e.length)]}function Zs(...e){return ae(e).reduce((t,n)=>t!=null?n>t?n:t:n,void 0)}function Ks(...e){return ae(e).reduce((t,n)=>t!=null?n<t?n:t:n,void 0)}function Ys(...e){return ae(e).reduce((t,n)=>t+n,0)}function Qs(...e){let t=ae(e);return t.reduce((n,r)=>n+r,0)/t.length}function Xs(e,t){let n=[],r=0,o=e.length;for(;r<o;)n.push(e.slice(r,r+=t));return n}function ea(e=0,t){if(e<=0)return [];let n=new Array(e);for(let r=0;r<e;r++)n[r]=t instanceof Function?t(r):t;return n}var eo={2:"01",8:"01234567",11:"0123456789a",16:"0123456789abcdef",32:"0123456789abcdefghjkmnpqrtuvwxyz","32-crockford":"0123456789ABCDEFGHJKMNPQRSTVWXYZ","32-geohash":"0123456789bcdefghjkmnpqrstuvwxyz","32-agnoster":"0123456789abcdefghjkmnpqrtuvwxyz","32-rfc":"ABCDEFGHIJKLMNOPQRSTUVWXYZ234567","32-hex":"0123456789ABCDEFGHIJKLMNOPQRSTUV","32-zbase":"ybndrfg8ejkmcpqxot1uwisza345h769",36:"0123456789abcdefghijklmnopqrstuvwxyz",58:"123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz",62:"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz",64:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/","64-url":"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_",66:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.!~",85:"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!#$%&()*+-;<=>?@^_`{|}~"};function to(e){let t=eo[String(e)];if(!t)if(typeof e=="string")t=e;else throw new Error(`Unknown base ${e}`);if(t.length>=255)throw new TypeError("Alphabet too long");let n=new Uint8Array(256);for(let c=0;c<n.length;c++)n[c]=255;for(let c=0;c<t.length;c++){let p=t.charAt(c),l=p.charCodeAt(0);if(n[l]!==255)throw new TypeError(`${p} is ambiguous`);n[l]=c;}let r=t.length,o=t.charAt(0),i=Math.log(r)/Math.log(256),a=Math.log(256)/Math.log(r);function s(c,p=-1){let l=U(c);if(l.byteLength===0)return "";let f=0,d=0,g=l.byteLength;for(;d!==g&&l[d]===0;)d++;let m=(g-d)*a+1>>>0,w=new Uint8Array(m);for(;d!==g;){let v=l[d],C=0;for(let h=m-1;(v!==0||C<f)&&h!==-1;h--,C++)v+=256*w[h]>>>0,w[h]=v%r>>>0,v=v/r>>>0;if(v!==0)throw new Error("Non-zero carry");f=C,d++;}let y=m-f;for(;y!==m&&w[y]===0;)y++;let T="";for(;y<m;++y)T+=t.charAt(w[y]);return p>0?T.padStart(p,o):T}function u(c,p=-1){if(typeof c!="string")throw new TypeError("Expected String");if(c.length===0)return new Uint8Array;c=c.replace(/\s+/gi,"");let l=0,f=0;for(;c[l]===o;)l++;let d=(c.length-l)*i+1>>>0,g=new Uint8Array(d);for(;c[l];){let w=n[c.charCodeAt(l)];if(w===255)throw new Error(`Unsupported character "${c[l]}"`);let y=0;for(let T=d-1;(w!==0||y<f)&&T!==-1;T--,y++)w+=r*g[T]>>>0,g[T]=w%256>>>0,w=w/256>>>0;if(w!==0)throw new Error("Non-zero carry");f=y,l++;}let m=d-f;for(;m!==d&&g[m]===0;)m++;return p>0?new Uint8Array([...new Uint8Array(p-g.length+m),...g.slice(m)]):g.slice(m)}return {encode:s,decode:u}}var Be;function q(e){Be==null&&(Be=new Map);function t(){let o=Be.get(e);return o==null&&(o=to(e),Be.set(e,o)),o}function n(o,i=-1){return t().encode(o,i)}function r(o,i=-1){return t().decode(o,i)}return {encode:n,decode:r}}function yt(e,t=-1){return q(32).encode(e,t)}function mn(e,t=-1){return q(32).decode(e.toLocaleLowerCase().replaceAll("l","1").replaceAll("s","5").replaceAll("o","0").replaceAll("i","1"),t)}function ra(e,t=-1){return q(16).encode(e,t)}function oa(e,t=-1){return q(16).decode(e,t)}function ia(e,t=-1){return q(58).encode(e,t)}function sa(e,t=-1){return q(58).decode(e,t)}function ht(e,t=-1){return q(62).encode(e,t)}function yn(e,t=-1){return q(62).decode(e,t)}function aa(e,t){return Math.ceil(e*(Math.log(256)/Math.log(t)))}var hn=e=>(e.length>0&&(/^[A-Z0-9_\-\ ]*$/g.test(e)&&(e=e.toLowerCase()),e=e.replace(/^[-_\ ]+/gi,"").replace(/[-_\ ]+$/gi,"").replace(/[-_\ ]+([a-z0-9])/gi,(t,n)=>n.toUpperCase()),e=e[0].toLowerCase()+e.substring(1)),e);function no(e){return e.charAt(0).toUpperCase()+e.toLowerCase().slice(1)}function ca(e){return e.replace(/\w\S*/g,no)}function la(e,t="-"){return t=typeof t>"u"?"_":t,e.replace(/([a-z\d])([A-Z])/g,`$1${t}$2`).replace(/([A-Z]+)([A-Z][a-z\d]+)/g,`$1${t}$2`).toLowerCase()}var xn=["1","true","yes","y","on"];function da(e,t=!1){return e==null||typeof e!="string"?t:xn.includes(String(e).trim().toLowerCase())}function ga(e,t=0){return e==null||typeof e!="string"?t:parseInt(e.trim(),10)??t}function ma(e,t=0){return e==null||typeof e!="string"?t:parseFloat(e.trim())??t}function ue(e,t=!1){return e==null?t:typeof e=="boolean"?e:typeof e=="number"?e!==0:xn.includes(String(e).trim().toLowerCase())}function ro(e,t=0){return e==null?t:typeof e=="boolean"?e?1:0:typeof e=="number"?Math.floor(e):parseInt(String(e).trim(),10)??t}function oo(e,t=0){return e==null?t:typeof e=="boolean"?e?1:0:typeof e=="number"?Math.floor(e):parseFloat(String(e).trim())??t}function xt(e,t=""){return e==null?t:String(e)??t}var ya=oo,ha=ro,xa=xt,ba=ue;function io(e,t={}){let{trace:n=!0,pretty:r=!0}=t;return e.map(o=>{if(o&&typeof o=="object"){if(r&&(o instanceof Uint8Array||o instanceof ArrayBuffer))return `
${qt(o)}
`;if(o instanceof Error)return n?`${o.name||"Error"}: ${o.message}
${o.stack}`:`${o.name||"Error"}: ${o.message}`;try{return r?JSON.stringify(o,null,2):JSON.stringify(o)}catch{}}return String(o)})}function $e(e,t={}){return io(e,t).join(" ")}function wa(e){try{return decodeURIComponent(escape(e))}catch{}return e}function Aa(e){if(e.startsWith("data:"))return ve(e.split(",",2)[1])}function va(e){if(e.startsWith("data:"))return e.slice(5).split(",",2)[0]}function Ea(e){if(e.startsWith("data:")){let[t,n]=e.slice(5).split(",",2);return new Blob([ve(n)],{type:t})}}async function Ua(e){let t=await e.arrayBuffer();if(t)return `data:${e.type},${fe(t)}`}function Ca(e,t="application/octet-stream"){return `data:${t},${fe(e)}`}var bn=864e5;function wt(e){return Math.floor(e/1e4)}function wn(e){return Math.floor(e/100%100)}function so(e){return Math.floor(e%100)}function Da(e){return [wt(e),wn(e),so(e)]}function Tn(e,t=!1){return t?new Date(`${uo(e)}T00:00:00.000Z`):new Date(e/1e4,e/100%100-1,e%100)}function Ln(){return _e(new Date)}function Sa(e,t=!1){if(typeof e=="number")return e<100?void 0:e;if(typeof e=="string")return An(e);if(Array.isArray(e)&&e.length===3){let[n,r,o]=e;return Tt(n,r,o)}else if(e instanceof Date)return _e(e,t)}function Pa(e){return Tn(e,!0)}function _e(e,t=!1){return t?An(e.toISOString()):e.getFullYear()*1e4+(e.getMonth()+1)*100+e.getDate()}function Ra(e){return _e(e,!0)}function bt(e,t=!0){return Tn(e,t).getTime()}function ao(e,t=!0){return _e(new Date(e),t)}function uo(e,t="-"){let n=String(e);return n.slice(0,4)+t+n.slice(4,6)+t+n.slice(6,8)}function Tt(e,t=1,n=1){if(!(t<1||t>12||n<1||n>31))return e*1e4+t*100+n}function An(e){let t=String(e).replace(/[^0-9]/g,"").slice(0,8);if(t.length===8)return +t}function ka(e,t=0){let n=wt(e),r=wn(e);return t!==0&&(r+=t,n+=Math.floor((r-1)/12),r=Math.floor((r-1)%12)+1,r===0&&(r=12)),Tt(n,r,1)}function Ia(e,t=0){let n=wt(e);return Tt(n+t,1,1)}function Oe(e,t){return ao(bt(e)+t*864e5)}function Ma(e,t){return Math.round((bt(t)-bt(e))/864e5)}function Ba(e,t){let n=[];for(t==null&&(t=Ln()),e<0&&(e=Oe(t,e+1));e<=t;)n.push(e),e=Oe(e,1);return n}function*$a(e,t){let n=[];for(t==null&&(t=Ln()),e<0&&(e=Oe(t,e+1));e<=t;)yield e,e=Oe(e,1);return n}function vn(){let e,t;return [new Promise((r,o)=>{e=r,t=o;}),e,t]}async function _a(e){return new Promise(t=>setTimeout(t,e))}async function ja(){return new Promise(e=>setTimeout(e,0))}async function Na(e,t,n="timeoutReached"){return new Promise(async(r,o)=>{let i=!1,a=setTimeout(()=>{i=!0,r(n);},t);try{let s=await e;clearTimeout(a),i||r(s);}catch(s){clearTimeout(a),i||o(s);}})}function Va(e){return e==="timeoutReached"||e?.name==="Timeout reached"}async function En(e,t){return t<=0?await e:new Promise(async(n,r)=>{let o=!1,i=setTimeout(()=>{o=!0,r(new Error("Timeout reached"));},t);try{let a=await e;clearTimeout(i),o||n(a);}catch(a){clearTimeout(i),o||r(a);}})}function Ha(e,t,n=1e3){return new Promise((r,o)=>{let i=u=>{s&&(clearTimeout(s),a(),r(u));},a=()=>{s=null,e.off?e.off(t,i):e.removeEventListener&&e.removeEventListener(t,i);},s=setTimeout(()=>{a(),o(new Error("Did not response in time"));},n);e.on?e.on(t,i):e.addEventListener&&e.addEventListener(t,i);})}function I(e){return !!(e&&(e instanceof Promise||typeof e.then=="function"))}function H(e){return Promise.resolve(e)}var A=class{get value(){return this.days}constructor(t){if(typeof t=="number"){this.days=t;return}if(t!=null&&(t=A.from(t)?.days),t==null){let n=new Date;this.days=n.getFullYear()*1e4+(n.getMonth()+1)*100+n.getDate();}else this.days=t;}static fromNumber(t){return new A(t)}static fromString(t){return A.from(+t.replace(/[^0-9]/g,"").slice(0,8))}static fromDate(t,n=!1){return n?A.fromString(t.toISOString().substr(0,10)):A.from(t.getFullYear()*1e4+(t.getMonth()+1)*100+t.getDate())}static fromDateGMT(t){return A.fromDate(t,!0)}static from(t,n=!1){if(typeof t=="number")return t<100?void 0:new A(t);if(typeof t=="string")return A.fromString(t);if(Array.isArray(t)&&t.length===3){let[r,o=1,i=1]=t;return o<1||o>12||i<1||i>31?void 0:new A(r*1e4+o*100+i)}else {if(t instanceof Date)return A.fromDate(t,n);if(t instanceof A)return t}}toNumber(){return this.days}toJson(){return this.days}toString(t="-"){let n=String(this.days);return n.slice(0,4)+t+n.slice(4,6)+t+n.slice(6,8)}toDate(t=!1){return t?new Date(`${this.toString()}T00:00:00.000Z`):new Date(this.days/1e4,this.days/100%100-1,this.days%100)}toDateGMT(){return this.toDate(!0)}get year(){return Math.floor(this.days/1e4)}get month(){return Math.floor(this.days/100%100)}get day(){return Math.floor(this.days%100)}dayOffset(t){return A.fromDateGMT(new Date(this.toDateGMT().getTime()+t*864e5))}monthStart(){return A.from([this.year,this.month,1])}yearStart(){return A.from([this.year,1,1])}monthOffset(t){let n=this.month+t,r=Math.floor((n-1)%12)+1;r===0&&(r=12);let o=Math.floor((n-1)/12);return A.from([this.year+o,r,this.day])}daysUntil(t){return Math.round((new A(t)?.toDateGMT().getTime()-this.toDateGMT().getTime())/864e5)}yesterday(){return this.dayOffset(-1)}tomorrow(){return this.dayOffset(1)}};async function Wa(e,t,n){let r=A.from(e),o=A.from(t);for(;r&&o&&r?.days<=o?.days;){let i=n(r);I(i)&&await i,r=r.dayOffset(1);}}function qa(){return new A}function Ja(e){return new A(e)}function Za(e){return A.fromDate(new Date(e)).days}function co(e,t=2){return +(+e).toFixed(t)}function Ya(e,t=2){return +(+e/10**t).toFixed(t)}function Qa(e,t=2){return Math.round(+e*10**t)}function Xa(e,t=2){return t*(co(e,t)%1)}function nu(e,t,n){let r=e[t];return r===void 0&&(r=n(t,e),e[t]=r),r}async function ru(e,t,n){let r=e[t];return r===void 0&&(r=await n(t,e),e[t]=r),r}function Un(e){return e!=null?e.size!=null?e.size:e.length!=null?e.length:Object.keys(e).length:0}function ou(e){return e!=null&&e.length>0?e[0]:void 0}function iu(e){return e!=null&&e.length>0?e[e.length-1]:void 0}function su(e){try{if(e!=null)return Array.isArray(e)||typeof e=="string"?e.length<=0:e?.size!=null?e.size<=0:Object.keys(e).length<=0}catch(t){console.warn("Failed to check if empty for",e,t);}return !0}function ce(e){return Object(e)!==e?e:JSON.parse(k(e))}function au(e){return Object(e)!==e?e:JSON.parse(k(e))}function uu(e){let t=new Map;return n=>{if(t.has(n))return t.get(n);let r=e(n);return t.set(n,r),r}}function cu(e){let t=new Map;return async(...n)=>{let r=k(n);if(t.has(r))return t.get(r);let o=await e(...n);return t.set(r,o),o}}function lu(e,t){let n=[];for(let r=0;r<e;r++)n.push(t(r,e));return n}function N(e){return e!=null&&typeof e=="object"}function Lt(e){return Object(e)!==e}function G(e){return Array.isArray(e)}function je(e){return N(e)&&!G(e)}function du(e){return e?.constructor===Object}function Cn(e){return typeof e=="string"}function Fn(e){return typeof e=="number"&&!isNaN(e)}function gu(e){return Fn(e)&&Number.isInteger(e)}function mu(e){return Fn(e)&&Number.isSafeInteger(e)}function Dn(e){return typeof e=="boolean"}function yu(e){return e==null}function hu(e){return e==null}function xu(e){return N(e)&&e.constructor.name==="Uint8Array"}function Sn(e){return e!=null}function lo(e){return e==null||e===""||N(e)&&Un(e)<=0}function bu(e){return !lo(e)}function wu(e){return e!=null&&e!==!1&&e!==!0}function Tu(e){return e!=null&&e!==!1&&e!==0&&e!==""}function fo(e,t,n=new WeakSet){if(e===t)return !0;if(n.has(t)||(Lt(t)||n.add(t),!(e instanceof Object)||!(t instanceof Object))||e.constructor!==t.constructor||e.length!==t.length)return !1;for(let r in e){if(!e.hasOwnProperty(r))continue;if(!t.hasOwnProperty(r))return !1;let o=e[r],i=t[r];if(!fo(o,i,n))return !1}for(let r in t)if(t.hasOwnProperty(r)&&!e.hasOwnProperty(r))return !1;return !0}function po(e,t=new WeakSet){if(t.has(e))return "[Circular ~]";if(Lt(e)||t.add(e),je(e)){for(let n in e)if(e.hasOwnProperty(n)){if(e[n]===void 0){delete e[n];continue}po(e[n],t);}}else if(G(e))for(let n=e.length-1;n>=0;n--)e[n]===void 0&&e.splice(n,1);return e}function Ne(e,...t){for(let n of t)N(e)||(e={}),!(n==null||!N(n))&&Object.keys(n).forEach(r=>{let o=e[r],i=n[r];Array.isArray(o)&&Array.isArray(i)?e[r]=o.concat(i):N(o)&&N(i)?e[r]=Ne(Object.assign({},o),i):e[r]=i;});return e}function go(e,t,n={cyclesFix:!0},r=[]){let o=[],i=Array.isArray(e);for(let s in e){let u=e[s],c=i?+s:s;if(!(s in t)){o.push({type:"del",path:[c]});continue}let p=t[s],l=typeof u=="object"&&typeof p=="object";if(u&&p&&l&&!["Date","RegExp","String","Number"].includes(Object.getPrototypeOf(u).constructor.name)&&(!n.cyclesFix||!r.includes(u))){let f=go(u,p,n,n.cyclesFix?r.concat([u]):[]);o=[...o,...f.map(d=>(d.path.unshift(c),d))];}else u!==p&&!(l&&(isNaN(u)?`${u}`==`${p}`:+u==+p))&&o.push({path:[c],type:"upd",value:p});}let a=Array.isArray(t);for(let s in t)s in e||o.push({type:"new",path:[a?+s:s],value:t[s]});return o}var Pn=e=>e.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/'/g,"&apos;").replace(/"/g,"&quot;"),Uu=e=>e.replace(/&lt;/gi,"<").replace(/&gt;/gi,">").replace(/&quot;/gi,'"').replace(/&apos;/gi,"'").replace(/&amp;/gi,"&");function Fu(e,t,n=[]){return e.filter(r=>!t.some(o=>!o(r))).map(r=>{for(let o of n)r=o(r);return r}).filter(r=>r!=null)}function Du(e,t){return e.reduce((n,r)=>{let o=String(r[t]);return (n[o]=n[o]||[]).push(r),n},{})}function Su(e,t){return Array.from(e.reduce((n,r)=>n.add(r[t]),new Set))}function Pu(e,t){return e.map(n=>n[t])}function Iu(e,t){return N(e)?Object.fromEntries(Object.entries(e).map(([n,r])=>{let o=t(n,r);return G(o)&&o.length===2?o:[n,o]}).filter(n=>n!=null)):{}}function Mu(e,t){return t.dispose&&e.dispose&&t.dispose.add(e.dispose),Object.assign(e,t)}function Bu(e){return Object.keys(e).length<=0}var mo=/[\\\-\[\]\/{}()*+?.^$|]/g;function Ve(e){return e?e instanceof RegExp?e.source:e.replace(mo,"\\$&"):""}var yo=100,ho=/^\.+/,xo=/\.+$/,bo=/[<>:\"/\\|?*\u0000-\u001F\u0080-\u009F]+/gm;function Rn(){return bo}function wo(){return /^(con|prn|aux|nul|com\d|lpt\d)$/i}function kn(e,t="_"){if(typeof e!="string")throw new TypeError("Expected a string");if(Rn().test(t))throw new Error("Replacement string cannot contain reserved filename characters");let n=`(${Ve(t)})+`;return e=e.replace(Rn(),t).replace(ho,t).replace(xo,"").replace(new RegExp(n,"gm"),t).trim(),e=wo().test(e)?e+t:e,e.slice(0,yo)}var ye=e=>Math.abs(e)%1===.5,In=e=>e%2===0,Nu=e=>Math.ceil(e),Vu=e=>Math.floor(e),Hu=e=>Math.round(e),Gu=e=>{let t=Math.round(e);return ye(e)&&In(t)?t-1:t},zu=e=>ye(e)?Math.sign(e)*Math.ceil(Math.abs(e)):Math.round(e),Wu=e=>ye(e)?Math.floor(e):Math.round(e),qu=e=>{let t=Math.round(e);return ye(e)?In(t)?t:t-1:t},Ju=e=>ye(e)?Math.sign(e)*Math.floor(Math.abs(e)):Math.round(e);function Mn(e){return e.reduce((t,n)=>Math.min(t,n.sort_weight||0),0)-1-S()}function Bn(e){return e.reduce((t,n)=>Math.max(t,n.sort_weight||0),0)+1+S()}function Yu(e,t,n){let r=n.length,o=e<t;if(r<=0||e>=r-1)return Bn(n);if(e<=0)return Mn(n);n=To([...n]);let i=o?-1:0,a=n[e+i].sort_weight||0,u=(n[e+i+1].sort_weight||0)-a;if(u===0)return o?Mn(n):Bn(n);let c=a+u/2,p=u*.01*(S()-.5);return c+p}function To(e){return e.sort((t,n)=>(t.sort_weight||0)-(n.sort_weight||0)),e}function ec(e={}){let{getter:t=s=>s.sort}=e;function n(s){return s.sort((u,c)=>(t(u)||0)-(t(c)||0)),s}function r(s){return s.reduce((u,c)=>Math.min(u,t(c)||0),0)-1-S()}function o(s){return s.reduce((u,c)=>Math.max(u,t(c)||0),0)+1+S()}function i(s,u){s==null&&(s=(u??0)-1),u==null&&(u=(s??0)+1);let c=u-s,p=s+c/2,l=c*.01*(S()-.5);return p+l}function a(s,u,c){let p=c.length,l=s<u;if(p<=0||s>=p-1)return o(c);if(s<=0)return r(c);c=n([...c]);let f=l?-1:0,d=t(c[s+f])||0,m=(t(c[s+f+1])||0)-d;if(m===0)return l?r(c):o(c);let w=d+m/2,y=m*.01*(S()-.5);return w+y}return {start:r,end:o,between:i,move:a,items:n}}var Lo=/((?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z0-9\u00A1-\uFFFF][a-z0-9\u00A1-\uFFFF_-]{0,62})?[a-z0-9\u00A1-\uFFFF]\.)+(?:[a-z\u00A1-\uFFFF]{2,}\.?))(?::\d{2,5})?(?:[/?#]\S*)?)/gim;function rc(e){return e.split(Lo).map((t,n)=>{let r=Pn(t);return n%2?`<a target="_blank" href="${r}">${Ao(r)}</a>`:r}).join("")}function Ao(e){return e.replace(/^https?:\/\/(www\.)?/,"").replace(/\/$/,"")}function $n(e){let t=[];for(let[n,r]of Object.entries(e))if(r!=null){Array.isArray(r)||(r=[r]);for(let o of r)o!=null&&t.push(`${encodeURIComponent(n)}=${encodeURIComponent(String(o))}`);}return t.join("&")}function oc(e){let t={},n=(e[0]==="?"?e.substr(1):e).split("&");for(let r=0;r<n.length;r++){let o=n[r].split("="),i=decodeURIComponent(o[0]),a=decodeURIComponent(o[1]||"");t[i]!=null?(Array.isArray(t[i])||(t[i]=[t[i]]),t[i].push(a)):t[i]=a;}return t}var vo=/\\\s|\s+|#[^\n]*\n?/gm,Eo=/\(\?P?<(\w[\w\d_]+)>|\((?!\?(:|\!|=|<=|<\!))/gm,On=/^((?:\(\?[\w$]+\))?)\(\?<([=!])([\s\S]*?)\)/gm;function Uo(e){return typeof e=="string"?e:e.source||""}function sc(e){return e.replace(/[-\[\]{}()*+?.,\\^$|#\s]/g,"\\$&")}var _n=class{constructor(t,n){this.namedGroups={};this.names=[];let r=n??"",o;if(t instanceof RegExp?(n==null&&(r=t.flags),o=t.source):o=t,r&&r.includes("x")&&(r=r.replace("x",""),o=o.replace(vo,s=>s[0]==="\\"?s:"")),!(t instanceof RegExp)){let s=0;o=o.replace(Eo,(u,c)=>(s+=1,c?(c!=="index"&&c!=="length"&&!this.namedGroups[c]&&(this.namedGroups[c]=s),"("):u)),this.names=Object.keys(this.namedGroups);}o=Uo(o),On.lastIndex=0;let a=On.exec(o);a&&(this.lookBehind={rx:new RegExp(`${a[3]}$(?!\\s)`),expect:a?a[2]==="=":!a},o=o.substr(a[0].length)),this.rx=new RegExp(o,r);}get lastIndex(){return this.rx.lastIndex}set lastIndex(t){this.rx.lastIndex=t;}_handleMatch(t){if(this.lookBehind){let n=t.input.slice(0,t.index);if(this.lookBehind.expect!==this.lookBehind.rx.test(n))return null}for(let n of this.names)t[n]=t[this.namedGroups[n]];return t}exec(t){let n;for(;n=this.rx.exec(t);)if(this.rx.lastIndex===n.index&&this.rx.lastIndex++,n=this._handleMatch(n),n!=null)return n}execAll(t){let n=[],r;for(this.rx.lastIndex=0;r=this.exec(t);)n.push(r);return this.rx.lastIndex=0,n}replace(t,n){let r=typeof n=="function"?n:()=>n;return t.replace(this.rx,o=>r(o))}};var Co=",";function cc(e,t={}){let{separator:n=Co}=t,r="";for(let o=0;o<e.length;o++)r+=`${e[o].map(i=>{if(i==null||i==="")return "";if(Dn(i))return i?1:0;let a=String(i);return (je(i)||G(i))&&(a=k(i)),a.includes('"')||a.includes(`
`)||a.includes(n)?`"${a.replace(/"/g,'""')}"`:a}).join(n)}
`;return r}function Fo(e,t={}){let n=/("((?:(?:[^"]*?)(?:"")?)*)"|([^,;\t\n]*))([,;\t]|\n|\r\n)/g;t.separator&&(n=new RegExp(n.source.replaceAll(",;\\t",Ve(t.separator)),n.flags));let r=[],o=[],i,a=`${e.replaceAll(`\r
`,`
`).trim()}
`;for(;i=n.exec(a);){let s=i[2]??i[3]??"";s=s.replaceAll('""','"'),o.push(s),i[4]===`
`&&(r.push(o),o=[]);}return r}function lc(e,t={}){let n=Fo(e,t),r=n[0];return n.slice(1).map(o=>Object.fromEntries(o.map((i,a)=>[r[a],i])))}async function Do(e){typeof e=="function"?await H(e()):I(e)?await e:typeof e.dispose=="function"?await H(e.dispose()):I(e.dispose)?await e.dispose:typeof e.cleanup=="function"?await H(e.cleanup()):I(e.cleanup)&&await e.cleanup;}function he(e){let t=e;t!=null&&(Cn(t)?t={name:t}:"debug"in t&&"label"in t&&(t={name:t.label,log:t}));let n=t?.name,r=t?.log??R("zeed:dispose"),o=[],i=async u=>{u!=null&&o.includes(u)&&(mt(o,c=>c!==u),await Do(u));},a=async()=>{for(n&&r.debug(`dispose "${n}": ${o.length} entries`);o.length>0;)await i(o[0]);},s=u=>{if(u!=null)return o.unshift(u),()=>i(u)};return Object.assign(a,{track:s,add:s,untrack:i,dispose:a,exec:a,getSize(){return o.length},isDisposed(){return o.length<=0}})}var yc=he;function hc(e={}){let{mode:t="fifo"}=e,n=[],r=async(i=!1)=>{for(;n.length>0;){let a=n[0];if(mt(n,s=>s!==a),typeof a=="function"){let s=a();if(I(s)){if(i)throw new Error(`Expected sync only function, but found async: ${a}`);await s;}}else if(I(a)){if(i)throw new Error(`Expected sync only function, but found async: ${a}`);await a;}else throw new Error(`Unhandled disposable: ${a}`)}};return Object.assign(r,{add:i=>{t==="lifo"?n.unshift(i):n.push(i);},exec:r,getSize(){return n.length}})}function xc(e,t=0){let n=setTimeout(e,t);return ()=>{n&&(clearTimeout(n),n=void 0);}}function bc(e,t){let n=setInterval(e,t);return ()=>{n&&(clearInterval(n),n=void 0);}}function wc(e,t,n,...r){return e==null?()=>{}:(e.on?e.on(t,n,...r):e.addEventListener&&e.addEventListener(t,n,...r),()=>{e.off?e.off(t,n,...r):e.removeEventListener&&e.removeEventListener(t,n,...r);})}function Ac(){let e=!0;return (t,n)=>{let r=!1;if(e){e=!1;try{t(),r=!0;}finally{e=!0;}}else n!==void 0&&n();return r}}function vc(){let e=!0;return async(t,n)=>{let r=!1;if(e){e=!1;try{let o=t();I(o)&&await o,r=!0;}finally{e=!0;}}else if(n!==void 0){let o=n();I(o)&&await o;}return r}}var M=class{constructor(){this.subscribers={};this.subscribersOnAny=[];this._logEmitter=R("zeed:emitter","error");this.dispose=he();this.call=new Proxy({},{get:(t,n)=>async(...r)=>await this.emit(n,...r)});}async emit(t,...n){let r=!1;try{let o=this.subscribers[t]||[];if(this._logEmitter.debug("emit",this?.constructor?.name,t,...n,o),this.subscribersOnAny.forEach(i=>i(t,...n)),o.length>0){let i=o.map(a=>{try{return H(a(...n))}catch(s){this._logEmitter.warn("emit warning:",s);}return null}).filter(a=>a!=null);r=!0,await Promise.all(i);}}catch(o){this._logEmitter.error("emit exception",o);}return r}onAny(t){this.subscribersOnAny.push(t);}on(t,n){let r=this.subscribers[t]||[];return r.push(n),this.subscribers[t]=r,()=>{this.off(t,n);}}onCall(t){for(let[n,r]of Object.entries(t))this.on(n,r);}once(t,n){let r=async(...o)=>(this.off(t,r),await H(n(...o)));return this.on(t,r),()=>{this.off(t,n);}}off(t,n){return this.subscribers[t]=(this.subscribers[t]||[]).filter(r=>n&&r!==n),this}removeAllListeners(){return this.subscribers={},this}};function Pc(){let e=X().emitter;return e||(e=new M,X().emitter=e),e}function Rc(e,t){let n=Math.round(S()*100),r=[],o,i=(s,u)=>{let c={key:s,obj:u};r.push(c),o&&o();};return t?e.on?e.on(t,s=>{i(t,s);}):e.addEventListener?e.addEventListener(t,s=>{i(t,s);}):e.log.error(n,"Cannot listen to key"):e.onAny?e.onAny((s,u)=>{i(s,u);}):e.log.error(n,"cannot listen to all for",e),(s,u=!0)=>new Promise((c,p)=>{s||(s=t,s||r.length&&(s=r[0].key)),o=()=>{for(;r.length>0;){let l=r.shift();if(l.key===s)o=void 0,c(l.obj);else {if(u)continue;p(new Error(`Expected ${s}, but found ${l.key} with value=${l.obj}`));}break}},o();})}var K=()=>Date.now();function At(e){return e>999?`${(e/1e3).toFixed(1)}s`:`${e.toFixed(2)}ms`}function Ic(...e){for(let t of e){if(t instanceof Date)return t;if(typeof t=="string"){let n=null;if(t.includes(":"))try{n=new Date(t);}catch{}if(!(n instanceof Date)){let r=/(\d\d\d\d)-(\d\d)-(\d\d)/.exec(t);r&&(n=new Date(+r[1],+r[2]-1,+r[3],12,0));}if(n instanceof Date)return n}}}var jn=()=>typeof performance<"u"?performance.now():Date.now();function Mc(){let e=jn();return function(){let t=jn()-e;return At(t)}}var He=16;function Et(){return se(He)}function So(e=Et()){return ht(e,22)}function Po(e){return ht(e,22)}function Ro(e){return yn(e,He)}function ko(e=Et()){return yt(e,26)}function Io(e){return yt(e,26)}function Mo(e){return mn(e,He)}var Bo="10000000-1000-4000-8000-100000000000",$o=function(){return typeof crypto<"u"&&crypto.randomUUID!=null?crypto.randomUUID():Bo.replace(/[018]/g,e=>(e^se(1)[0]&15>>e/4).toString(16))};function Oo(e){let t=Gt(e);return `${t.slice(0,8)}-${t.slice(8,12)}-${t.slice(12,16)}-${t.slice(16)}`}function _o(e){return zt(e.replaceAll("-",""))}var Nn=16e11;function jo(e){let t=new Uint8Array([0,0,0,0,0,0]),n=t.length-1;for(let r=0;r<t.length;r++){let o=e&255;t[n-r]=o,e=(e-o)/256;}return t}function Vn(){let e=K()-Nn;return new Uint8Array([...jo(e),...se(10)])}function Nc(){return Vo(Vn())}function Vc(e){return No(Gn(e))}function No(e){return new Date(Nn+e.slice(0,6).reduce((t,n)=>t*256+n,0))}function Hc(){return new Uint32Array(se(4))[0]}var Ut={base62:{uuid:So,uuidDecode:Ro,uuidEncode:Po},base32:{uuid:ko,uuidDecode:Mo,uuidEncode:Io},uuidv4:{uuid:$o,uuidDecode:_o,uuidEncode:Oo}},Ge="base62",Hn=!1;function Gc(e,t=!1){Ge=e,Hn=t;}function Y(){return Ut[Ge].uuid(Hn?Vn():Et())}function Gn(e){return Ut[Ge].uuidDecode(e)}function Vo(e){return Ut[Ge].uuidEncode(e)}function zc(e){try{return Gn(e).length===He}catch{}return !1}var vt={};function _(e="id"){return vt[e]==null&&(vt[e]=0),`${e}-${vt[e]++}`}var Ho=0;function Wc(){return `id-${Ho++}`}var Ct=class extends M{constructor(){super(...arguments);this.id=Y();}close(){this.dispose();}},ze=class extends Ct{constructor(){super(...arguments);this.isConnected=!0;}postMessage(n){this.other?.emit("message",{data:n,origin:"local",lastEventId:Y()});}};function Kc(){let e=new ze,t=new ze;return e.other=t,t.other=e,[e,t]}var zn=class{async encode(t){return t}async decode(t){return t}},le=class{async encode(t){return Xe(t)}async decode(t){return et(t)}},Wn=class{constructor(t){this.key=t;}async encode(t){let n=Xe(t);return await fn(n,this.key)}async decode(t){let n=await pn(t,this.key);return et(n)}};var qn=(e,t,n={})=>new Proxy(n,{get:(r,o)=>o in r?r[o]:(...i)=>e(o,i,t)});function sl(e={}){let{name:t=_("hub"),encoder:n=new le,retryAfter:r=1e3,ignoreUnhandled:o=!0,logLevel:i=!1}=e,a=R(t,i),s={},u,c=[],p,l={},f=()=>{clearTimeout(p);},d=async()=>{if(clearTimeout(p),u){if(u.isConnected)for(;c.length;){let y=c[0];try{u.postMessage(await n.encode(y)),c.shift();}catch(T){a.warn("postMessage",T);break}}c.length>0&&r>0&&(p=setTimeout(d,r));}},g=async y=>{a("enqueue postMessage",y),c.push(y),await d();},m=async y=>{u=y,u.on("connect",d),u.on("message",async T=>{a("onmessage",typeof T);let{name:v,args:C,id:h,result:x,error:L}=await n.decode(T.data);if(v){a(`name ${v} id ${h}`);try{if(s[v]==null)throw new Error(`handler for ${v} was not found`);let E=s[v](...C);I(E)&&(E=await E),a(`result ${E}`),h&&await g({id:h,result:E});}catch(E){let b=E instanceof Error?E:new Error(xt(E));a.warn("execution error",b.name),await g({id:h,error:{message:b.message,stack:b.stack,name:b.name}});}}else if(h)if(a(`response for id=${h}: result=${x}, error=${L}`),l[h]==null)x===void 0?a(`skip response for ${h}`):a.warn(`no response hook for ${h}`);else {let[E,b]=l[h];if(E&&b)if(delete l[h],L){let D=new Error(L.message);D.stack=L.stack,D.name=L.name,a.warn("reject",D.name),b(D);}else a("resolve",x),E(x);}else o||a.warn("Unhandled message",T);}),await d();},w=async(y,T,v={})=>{let{timeout:C=5e3}=v,h=Y();return await g({name:y,args:T,id:h}),En(new Promise((x,L)=>l[h]=[x,L]),C)};return e.channel&&m(e.channel),{dispose:f,connect:m,listen(y){Object.assign(s,y);},send(){return qn(w,{},{options(y){return qn(w,{...y})}})}}}var Ft=class extends M{constructor(n){super();this.publish=this.emit.bind(this);this.subscribe=this.on.bind(this);let{name:r,encoder:o=new le,channel:i,debug:a=!1}=n;this.channel=i,this.encoder=o,this.debug=a,this.name=r??this.channel.id??_("pubsub"),this.log=R(`${this.shortId}`),this.debug&&(this.channel.on("connect",()=>{this.log("channel connected");}),this.channel.on("disconnect",()=>{this.log("channel disconnected");})),this.channel.on("message",async({data:s})=>{let u=await this.encoder.decode(s);if(this.debug?this.log(`channel message, event=${u?.event}, info=`,u):this.log(`channel message, event=${u?.event}`),u){let{event:c,args:p}=u;await this.emitSuper(c,...p);}});}get shortId(){return this.name.substr(0,6)}async emitSuper(n,...r){return await super.emit(n,...r)}async emit(n,...r){try{if(this.debug?this.log(`emit(${String(n)})`,n):this.log(`emit(${String(n)})`,r.length),!this.channel.isConnected)return this.log.warn("channel not connected"),!1;let o=await this.encoder.encode({event:n,args:r});return this.channel.postMessage(o),!0}catch(o){this.log.warn(`emit(${String(n)})`,o);}return !1}};function pl(e){return new Ft(e)}var Go=1;var Jn=e=>e,zo=Jn;function gl(e,t){let{post:n,on:r,eventNames:o=[],serialize:i=Jn,deserialize:a=zo}=t,s=new Map;return r(async u=>{let c=a(u),[p,l,f,d]=c;if(p===1||p===2){let g,m;if(d!=null)try{let w=e[d];g=await w(...l);}catch(w){m=String(w);}else m="Method implementation missing";p===1&&f&&n(i(m?[4,m,f]:[3,g,f]));}else if(f){let g=s.get(f);g!=null&&(p===4?g.reject(l):g.resolve(l)),s.delete(f);}}),new Proxy({},{get(u,c){let p=(...f)=>{n(i([2,f,null,c]));};if(t.onlyEvents||o.includes(c))return p.asEvent=p,p;let l=(...f)=>new Promise((d,g)=>{let m=Go++;s.set(m,{resolve:d,reject:g}),n(i([1,f,m,c]));});return l.asEvent=p,l}})}var Q=class extends M{constructor(n={}){super();this._isCancelled=!1;this._resetWhenFinished=!0;this._children=[];this._totalUnits=n.totalUnits??0,this._completedUnits=n.completeUnits??0,this._resetWhenFinished=n.resetWhenFinished??!0,this.name=n.name??_("progress"),this.dispose.add(async()=>{for(let r of this._children)await r.dispose();await this.emit("progressDispose",this);});}update(){this.emit("progressChanged",this),this._isCancelled&&this._resetWhenFinished&&this.getTotalUnits()<=this.getCompletedUnits()&&this.reset();}reset(){if(this._isCancelled){this._isCancelled=!1;for(let n of this._children)n.reset();this.update();}}async cancel(){if(!this._isCancelled){this._isCancelled=!0,await this.emit("progressCancelled",this);for(let n of this._children)await n.cancel();this.update();}}addChild(n){n.on("progressDispose",()=>this.removeChild(n)),n.on("progressChanged",()=>this.update()),this._children.includes(n)||this._children.push(n),this.update();}createChildProgress(n){let r=new Q(n);return this.addChild(r),r}removeChild(n){dn(this._children,n),this.update();}getTotalUnits(){if(this.isIndeterminate())return 0;let n=this._totalUnits;for(let r of this._children)n+=r.getTotalUnits();return n}getCompletedUnits(){if(this.isIndeterminate())return 0;let n=this._completedUnits;for(let r of this._children)n+=r.getCompletedUnits();return n}isIndeterminate(){return this._totalUnits<=0&&this._children.length<=0}isCancelled(){return this._isCancelled}isFinished(){return this.dispose.isDisposed()||!this.isIndeterminate()&&this.getTotalUnits()<=this.getCompletedUnits()}getFraction(){if(this.isIndeterminate())return 0;let n=this.getCompletedUnits()/this.getTotalUnits();return isNaN(n)&&(n=0),Math.min(1,Math.max(0,n))}getChildrenCount(){return this._children.length}setTotalUnits(n,r){this._totalUnits=n,r!=null&&(this._completedUnits=r),this.update();}incTotalUnits(n=1){this._totalUnits+=n,this.update();}setCompletetedUnits(n){this._completedUnits=n,this.update();}setCompleted(){this._completedUnits=this._totalUnits,this.update();}incCompletedUnits(n=1){this._completedUnits+=n,this.update();}toString(n=0){let r=`${"  ".repeat(n)}${this.name}: ${this._completedUnits} of ${this._totalUnits} units, ${Math.floor(this.getFraction()*100)} %, cancel=${this._isCancelled}
`;for(let o of this._children)r+=o.toString(n+1);return n===0?r.trim():r}};function El(e={}){let{maxParallel:t=3,name:n=_("pool"),idConflictResolution:r="memoize"}=e,o=new M,i=he();i.add(T);let a=new Q({name:n});a.on("progressCancelled",T);let s=0,u=0,c=0,p=0,l={};async function f(){if(s>0){let[h,x]=vn();return o.once("didFinish",x),h}}async function d(){for(let h of Object.keys(l))l[h].state==="finished"&&(await l[h].progress.dispose(),delete l[h]);}function g(){o.emit("didFinish"),s=0,u=0,d(),a.reset();}function m(){let h=0,x=0;for(let{max:L,resolved:E,state:b}of Object.values(l))h+=L,x+=b==="finished"?L:Math.min(L,E);o.emit("didUpdate",s,u,h,x);}function w(){if(m(),s>0&&s===u&&g(),c>=t)return;let h=Object.values(l).filter(x=>x.state==="waiting");if(h.length>0){let x;for(let L of h)L.group!=null&&Object.values(l).some(E=>E.state==="running"&&E.id!==L.id&&E.group===L.group)||(x==null||L.priority<x.priority)&&(x=L);if(x!=null){let L=x.id,E=x.done;x.state="running",++c,o.emit("didStart",L);let b=D=>{x&&(x.result=D,x.state="finished",x.resolved=x.max,x.progress?.setCompleted()),--c,++u,w();};x.task(x).then(D=>{E(D),o.emit("didResolve",L,D),b(D);}).catch(D=>{E(),o.emit("didReject",L,D),b();});}}}function y(h){let x=l[h];x&&x.state==="waiting"&&(l[h].state="finished",++u,o.emit("didCancel",h),l[h].progress.dispose(),m());}function T(){Object.keys(l).forEach(y);}function v(h){return l[h]!=null}function C(h,x={}){let L,E=new Promise(P=>L=P),b=x.id??Y();if(l[b]!=null){let P=x.idConflictResolution??r;if(P==="replace")y(b);else if(P==="memoize"||P==="prioritize"){let $t=l[b];return P==="prioritize"&&($t.priority=++p),{id:b,promise:(async()=>{if($t.state==="finished")return l[b].result})(),dispose:()=>y(b),cancel:()=>y(b)}}else throw new Error(`Pool task with id=${b} already exists!`)}let D=new Q({name:b,totalUnits:x.max??1,completeUnits:x.resolved??0});return a.addChild(D),l[b]={id:b,task:h,priority:++p,group:x.group,state:"waiting",max:x.max??1,resolved:x.resolved??0,done:L,payload:x.payload,progress:D,setMax(P){D.setTotalUnits(P),l[b].max=P,m();},setResolved(P){D.setCompletetedUnits(P),l[b].resolved=P,m();},incResolved(P=1){D.incCompletedUnits(P),l[b].resolved+=P,m();}},++s,w(),{id:b,promise:E,dispose:()=>y(b),cancel:()=>y(b)}}return {events:o,cancel:y,cancelAll:T,hasById:v,progress:a,enqueue:C,dispose:i,waitFinishAll:f}}var Zn=class extends M{constructor(n={}){super();this.queue=[];this.waitToFinish=[];this.countMax=0;this.countResolved=0;this.paused=!1;let{name:r=_("queue"),logLevel:o}=n;this.name=r,this.log=R(`zeed:queue:${r}`,o??ee);}async performNext(){if(this.log("performNext, queue.length =",this.queue.length),this.currentTask!=null){this.log("performNext => skip while another task is running");return}if(this.paused){this.log("performNext => skip while is paused");return}for(;this.currentTask==null&&!this.paused;){let n=this.queue.shift();if(this.log(`performNext => ${n?.name}`),n==null)break;this.countResolved===0&&this.emit("didStart",this.countMax);let{name:r,task:o,resolve:i}=n;this.currentTask=o();let a;try{this.log.info(`start task ${r}`),a=await this.currentTask,this.log(`finished task ${r} with result =`,a);}catch(s){this.log.warn("Error performing task",s);}i(a),this.currentTask=void 0,this.countResolved+=1,this.emit("didUpdate",this.countMax,this.countResolved);}for(this.queue.length===0&&(this.emit("didFinish"),this.countMax=0,this.countResolved=0);this.waitToFinish.length>0;)this.waitToFinish.shift()();}async enqueue(n,r={}){let{immediate:o=!1,name:i=_(this.name)}=r;return o?(this.log.info(`immediate execution ${i}`),await n()):(this.log(`enqueue ${i}`),new Promise(a=>{this.queue.push({name:i,task:n,resolve:a}),this.countMax+=1,this.emit("didUpdate",this.countMax,this.countResolved),this.performNext();}))}async enqueueReentrant(n,r={}){return this.enqueue(n,{immediate:this.currentTask!=null,name:r.name})}async cancelAll(n=!0){this.log("cancelAll"),this.emit("didCancel");let r=this.queue.map(o=>o.resolve);this.queue=[],r.forEach(o=>o(void 0)),await this.wait();}async pause(){this.log("pause"),this.paused=!0,await this.wait();}resume(){this.log("resume"),this.paused=!1,this.performNext();}async wait(){if(this.log("wait"),!(this.currentTask==null&&(this.queue.length===0||this.paused)))return new Promise(n=>{this.waitToFinish.push(n);})}get isPaused(){return this.paused}get hasTasks(){return this.queue.length!==0}};function kl(e,t={}){let{delay:n=100,trailing:r=!0,leading:o=!0}=t,i=0,a=0,s=0,u;function c(){return i?(clearTimeout(i),i=void 0,!0):!1}function p(...l){let f=Date.now(),d=f-a,g=()=>{s=0,a=Date.now(),e.apply(this,l);};if(u=g,d>n||!i){o&&(d>n?g():++s);let m=d>n?n:n-d;c(),a=f,i=setTimeout(()=>{i=0,r&&(!o||s>0)&&u?.();},m);}else ++s;}return p.cancel=c,p.stop=()=>{c()&&u&&u();},p.immediate=async function(...f){c(),a=Date.now(),e.apply(this,f);},p.dispose=()=>p.stop(),p}function Il(e,t={}){let{delay:n=100}=t,r=0,o=!1,i;function a(){r&&(clearTimeout(r),r=0);}async function s(){try{if(a(),i!=null){let p=[...i];i=void 0,o=!0,await H(e(...p)),o=!1,i!=null&&(a(),r=setTimeout(s,n));}}catch{}}function u(...p){i=[...p],a(),o===!1&&(r=setTimeout(s,n));}async function c(...p){a(),i=[...p],await s();}return u.cancel=a,u.dispose=a,u.immediate=c,u}function Bl(e=globalThis?.location?.hostname??""){return ["::ffff:127.0.0.1","localhost","127.0.0.1","","::1","::"].includes(e)||e.startsWith("192.168.")||e.startsWith("10.0.")||e.endsWith(".local")}var Kn=["#0000CC","#0000FF","#0033CC","#0033FF","#0066CC","#0066FF","#0099CC","#0099FF","#00CC00","#00CC33","#00CC66","#00CC99","#00CCCC","#00CCFF","#3300CC","#3300FF","#3333CC","#3333FF","#3366CC","#3366FF","#3399CC","#3399FF","#33CC00","#33CC33","#33CC66","#33CC99","#33CCCC","#33CCFF","#6600CC","#6600FF","#6633CC","#6633FF","#66CC00","#66CC33","#9900CC","#9900FF","#9933CC","#9933FF","#99CC00","#99CC33","#CC0000","#CC0033","#CC0066","#CC0099","#CC00CC","#CC00FF","#CC3300","#CC3333","#CC3366","#CC3399","#CC33CC","#CC33FF","#CC6600","#CC6633","#CC9900","#CC9933","#CCCC00","#CCCC33","#FF0000","#FF0033","#FF0066","#FF0099","#FF00CC","#FF00FF","#FF3300","#FF3333","#FF3366","#FF3399","#FF33CC","#FF33FF","#FF6600","#FF6633","#FF9900","#FF9933","#FFCC00","#FFCC33"];function Ol(e){let t=0;for(let n=0;n<e.length;n++)t=(t<<5)-t+e.charCodeAt(n),t|=0;return Kn[Math.abs(t)%Kn.length]}function Vl(e){let{level:t=void 0,filter:n=void 0,messages:r=[]}=e,o=j(n),i=z(t);return a=>{i(a.level)&&o(a.name)&&(a.timestamp=K(),r.push(a));}}var Dt={cache:"no-cache",redirect:"follow",headers:{}};function Wo(e){let t=/:\/\/([^@]*)@/gi.exec(e);if(t&&t[1]){let[n,r]=t[1].split(":",2);return {url:e.replace(`${t[1]}@`,""),username:n,password:r}}}async function Yn(e,t={},n=fetch){try{G(t)&&(t=Ne({},...ae(t)));let r=Wo(String(e));r&&(e=r.url,t=Ne({},t,qo(r.username,r.password))),t.headers!=null&&!(t.headers instanceof Headers)&&(t.headers=new Headers(t.headers));let o=await n(String(e),t);if(o.status<400)return o;let i=R("zeed:network");try{i.warn(`Fetch of ${String(e)} returned status=${o.status}. Options:`,t),i.warn(`Response: ${await o.text()}`);}catch(a){i.error("Exception:",a);}}catch(r){R("zeed:network").error("fetchBasic",r);}}async function ql(e,t={},n=fetch){try{let r=await Yn(e,[{method:"GET",headers:{Accept:"application/json"}},t],n);if(r)return await r.json()}catch(r){R("zeed:network").error("fetchJSON error:",r);}}async function Jl(e,t={},n=fetch){try{let r=await Yn(e,[Dt,{method:"GET"},t],n);if(r)return await r.text()}catch(r){R("zeed:network").error("fetchHTML error:",r);}}function Zl(e,t="POST"){return {method:t,...Dt,headers:{"Content-Type":"application/x-www-form-urlencoded; charset=utf-8"},body:$n(e)}}function Kl(e,t="POST"){return {method:t,...Dt,headers:{"Content-Type":"application/json; charset=utf-8"},body:k(e)}}function qo(e,t){return {headers:{Authorization:`Basic ${fe(`${e}:${t}`)}`}}}function Qn(){if(typeof window<"u")return window}function Jo(){if(typeof navigator<"u")return navigator}function Ql(){return Qn()??typeof WorkerGlobalScope<"u"?self:typeof global<"u"?global:Function("return this;")()}function Xl(e={ios:!1,macos:!1,windows:!1,beaker:!1,electron:!1,wkwebview:!1,pwa:!1,pwaInstalled:!1,browser:!1,node:!1,worker:!1,test:!1,jest:!1,macosNative:!1,iosNative:!1,appleNative:!1,touch:!1}){let t=Jo(),n=Qn();return e.ios=t?.platform?.match(/(iPhone|iPod|iPad)/i)!=null,e.macos=!!t?.platform?.startsWith("Mac"),e.windows=!!t?.platform?.startsWith("Win"),e.beaker=n?.beaker!=null,e.electron=(t?.userAgent?.toLowerCase()?.indexOf(" electron/")||-1)>-1&&!e.beaker,e.wkwebview=n?.webkit?.messageHandlers!=null,e.pwa=t?.serviceWorker!=null,e.pwaInstalled=t?.standalone||n?.matchMedia?.("(display-mode: standalone)")?.matches,e.node=typeof process<"u"&&process?.release?.name==="node",e.browser=!e.electron&&!e.wkwebview&&!e.node,e.worker=typeof WorkerGlobalScope<"u"&&self instanceof WorkerGlobalScope,e.jest=typeof jest<"u"||typeof vitest<"u",e.test=e.jest,e.macosNative=e.wkwebview&&e.macos,e.iosNative=e.wkwebview&&e.ios,e.appleNative=e.wkwebview,e.touch=n&&"ontouchstart"in n||(t?.maxTouchPoints||0)>1||t?.msPointerEnabled&&n?.MSGesture||n?.DocumentTouch&&document instanceof DocumentTouch,e}function Zo(){return typeof window<"u"&&globalThis===window}function ef(e){Zo()?window.addEventListener("beforeunload",e):typeof process<"u"&&process.on("exit",()=>e);}var Xn=class{constructor(t={}){this.store={};}setItem(t,n){this.store[t]=ce(n);}getItem(t){return ce(this.store[t])}removeItem(t){delete this.store[t];}clear(){this.store={};}allKeys(){return Object.keys(this.store)}};var of=()=>{};function uf(e={}){let{args:t=process.argv.slice(1),alias:n={},normalize:r=hn,booleanArgs:o=[],listArgs:i=[],numberArgs:a=[]}=e,s=Object.entries(n).reduce((f,d)=>{let[g,m]=d;typeof m=="string"&&(m=[m]);for(let w of m)f[r(w)]=r(g);return f},{}),u={_:[]};function c(f,d){u[f]==null||typeof u[f]=="boolean"?u[f]=d:Array.isArray(u[f])?u[f].push(d):u[f]=[u[f],d];}let p=[...t],l;for(;l=p.shift();){let f;if(/^--?/.test(l)){let d=l.replace(/^--?/,"");if(l.includes("=")){let[g,m]=d.split("=",2);d=g.trim(),f=m.trim();}d=r(d),d=s[d]??d,o.includes(d)?c(d,!0):(f=f??p.shift()??"",a.includes(d)&&(f=Number(f??0)),i.includes(d)?Array.isArray(u[d])?u[d].push(f):u[d]=[f]:c(d,f));}else u._.push(l);}return u}function lf(e){return new Promise((t,n)=>{import('child_process').then(({spawn:r})=>{let o=r("pbcopy");o.on("error",i=>n(i)),o.on("close",()=>t(e)),o.stdin.write(e),o.stdin.end();}).catch(()=>{});})}function df(){try{typeof globalThis<"u"&&typeof globalThis.crypto>"u"&&St__default.default&&St__default.default.webcrypto&&(globalThis.crypto=St__default.default.webcrypto);}catch(e){console.warn("Failed to polyfill webcrypto",e);}}async function gf(){if(globalThis.crypto==null)try{if(typeof globalThis<"u"&&typeof globalThis.crypto>"u"){let e=await import('crypto');globalThis.crypto=e.webcrypto;}}catch(e){console.warn("Failed to polyfill webcrypto",e);}return globalThis.crypto}var Yo=`
`,Qo=/^\s*([\w_.-]+)\s*=\s*(.*)?\s*$/,Xo=/\\n/g,ei=/\n|\r|\r\n/;function er(e,t={}){let n={};return String(e).split(ei).forEach((r,o)=>{let i=r.match(Qo);if(i!=null){let a=i[1],s=i[2]||"",u=s.length-1,c=s[0]==='"'&&s[u]==='"';s[0]==="'"&&s[u]==="'"||c?(s=s.substring(1,u),c&&(s=s.replace(Xo,Yo))):s=s.trim(),n[a]=s;}}),n}function ti(e,t="."){return path.resolve(process.cwd(),e??t)}function ni(e,t=""){return e==null&&(e=t),ti(String(e).trim(),t)}var Pt=ni;function xf(e,t=process.env){if(t[e]!=null)return t[e];e=e.toLowerCase();for(let[n,r]of Object.entries(t))if(n.toLowerCase()===e)return r}function bf(e={}){let t=e?.path??Pt(e?.filename??".env"),n=e?.encoding??"utf8",r=e?.debug||!1;try{let o=We__default.default.existsSync(t)?er(We__default.default.readFileSync(t,{encoding:n}),{debug:r}):{},i=We__default.default.existsSync(`${t}.local`)?er(We__default.default.readFileSync(`${t}.local`,{encoding:n}),{debug:r}):{},a=Object.assign({},o,i),s=e?.env??process.env;return Object.entries(a).forEach(([u,c])=>{typeof e?.prefix=="string"&&(u=e?.prefix+u),Object.prototype.hasOwnProperty.call(s,u)||c!=null&&(s[u]=c);}),{parsed:a}}catch(o){return {error:o}}}function Af(e){let t=path.normalize(e),n=process.env.HOME;return n&&t.startsWith(n)?`~${t.slice(n.length)}`:t}async function kt(e){try{await promises.stat(e);}catch{return !1}return !0}function qe(e){return e.startsWith(".")||e.includes("/.")}async function vf(...e){let t=path.join(...e);return await kt(t)||await promises.mkdir(t,{recursive:!0}),t}async function Ef(...e){let t=path.join(...e);return await kt(t)&&await promises.rm(t,{recursive:!0}),t}async function Uf(...e){let t=path.join(...e);if(await kt(t))return await promises.readFile(t,"utf-8")}async function Cf(e,t){await promises.writeFile(e,t,"utf-8");}function Je(e,t){if(typeof e!="string")throw new TypeError("Expected a string");let n=String(e),r="",o=t?!!t.extended:!1,i=t?!!t.globstar:!1,a=!1,s=t&&typeof t.flags=="string"?t.flags:"",u;for(let c=0,p=n.length;c<p;c++)switch(u=n[c],u){case"/":case"$":case"^":case"+":case".":case"(":case")":case"=":case"!":case"|":r+=`\\${u}`;break;case"?":o&&(r+=".");break;case"[":case"]":o&&(r+=u);break;case"{":o&&(a=!0,r+="(");break;case"}":o&&(a=!1,r+=")");break;case",":a?r+="|":r+=`\\${u}`;break;case"*":{let l=n[c-1],f=1;for(;n[c+1]==="*";)f++,c++;let d=n[c+1];i?f>1&&(l==="/"||l===void 0)&&(d==="/"||d===void 0)?(r+="((?:[^/]*(?:/|$))*)",c++):r+="([^/]*)":r+=".*";}break;default:r+=u;}return (!s||!~s.indexOf("g"))&&(r=`^${r}$`),new RegExp(r,s)}function nr(e){try{return We.statSync(e)}catch{}}function If(e){let{mtimeMs:t,size:n}=nr(e)??{};return `${e}|${t}|${n}`}function rr(e,t="",n=!0){let r=[],o=We.readdirSync(path.resolve(e,t));if(o!=null&&o.length>0)for(let i of o){if(i=path.join(t,i),n&&qe(i))continue;let a=path.join(e,i),s=nr(a);s&&s.isDirectory()?r=r.concat(rr(e,i)||[]):r.push(i);}return r}function Mf(e={}){let{pattern:t,filter:n,basePath:r=process.cwd(),ignoreHidden:o=!1}=e,i=rr(r,"",o);if(i=i.filter(a=>!(o&&(a.startsWith(".")||a.includes("/.")))),t&&(typeof t=="string"&&(t=Je(t)),t instanceof RegExp)){let a=t;a.lastIndex=0,i=i.filter(s=>a.test(s));}return n&&(i=i.filter(n)),i}async function ir(e){try{return await promises.stat(e)}catch{}}async function Nf(e){let{mtimeMs:t,size:n}=await ir(e)??{};return `${e}|${t}|${n}`}async function sr(e,t="",n=!0){let r=[],o=await promises.readdir(path.resolve(e,t));if(o!=null&&o.length>0)for(let i of o){if(i=path.join(t,i),n&&qe(i))continue;let a=path.join(e,i),s=await ir(a);s&&s.isDirectory()?r=r.concat(await sr(e,i)||[]):r.push(i);}return r}async function Vf(e={}){let{pattern:t,filter:n,basePath:r=process.cwd(),ignoreHidden:o=!1}=e,i=await sr(r,"",o);if(i=i.filter(a=>!(o&&(a.startsWith(".")||a.includes("/.")))),t&&(typeof t=="string"&&(t=Je(t)),t instanceof RegExp)){let a=t;a.lastIndex=0,i=i.filter(s=>a.test(s));}return n&&(i=i.filter(n)),i}var cr=class{constructor(t={}){this.store={};this.fileKeys=void 0;this.pretty=!1;this.dirname=path.resolve(process.cwd(),t.path??".fileStorage"),this.pretty=!!t.pretty,this.extension=t.extension??".json",t.extension&&!this.extension.startsWith(".")&&(this.extension=`.${this.extension}`),this.extensionLength=this.extension.length,this.objectToString=t.objectToString??(n=>this.pretty?k(n,null,2):k(n)),this.objectFromString=t.objectFromString??(n=>{try{return JSON.parse(n)}catch{}}),this.keyToFilename=t.keyToFilename??kn;}setItem(t,n){this.store[t]=ce(n);try{let r=this.objectToString(n),o=this.getPath(t);We.mkdirSync(path.dirname(o),{recursive:!0}),We.writeFileSync(o,r,"utf8");}catch{}}getPath(t){return path.resolve(this.dirname,this.keyToFilename(t)+this.extension)}getBuffer(t){let n=this.getPath(t);return Buffer.from(We.readFileSync(n))}getItem(t){let n=this.store[t];if(n!==null){if(n!=null)return ce(n);try{let r=this.getPath(t),o=We.readFileSync(r,"utf8");if(o!=null){let i=this.objectFromString(o);return this.store[t]=i,i}}catch{this.store[t]=null;}}}removeItem(t){if(delete this.store[t],this.fileKeys!=null){let n=this.fileKeys.indexOf(t);n!==-1&&this.fileKeys.splice(n,1);}try{let n=this.getPath(t);We.unlinkSync(n);}catch{}}clear(){this.fileKeys=[],this.store={},We.rmSync(this.dirname,{recursive:!0,force:!0});}allKeys(){if(this.fileKeys==null)try{this.fileKeys=We.readdirSync(this.dirname,{withFileTypes:!0}).filter(n=>!n.isDirectory()&&n.name.endsWith(this.extension)).map(n=>n.name.slice(0,-this.extensionLength))||[];}catch{}let t=[...this.fileKeys||[]];for(let n of Object.keys(this.store))t.includes(n)||t.push(n);return t.sort(),t}};var lr={};function fr(e,t={}){let{level:n=void 0,filter:r=void 0,time:o=!0,pretty:i=!1}=t;e=path.resolve(process.cwd(),e),We.mkdirSync(path.dirname(e),{recursive:!0});let a=We.createWriteStream(e,{flags:"a"}),s=j(r),u=z(n);return c=>{if(!u(c.level)||!s(c.name))return;let p=o?`${new Date().toISOString()} `:"",l=c.name||"",f=lr[l||""];f==null&&(lr[l]=f);let d=[`[${l||"*"}]`,$e(c.messages,{pretty:i})];function g(...m){a.write(`${m.join("	")}
`);}switch(c.level){case O:g(`${p}I|*  `,...d);break;case B:g(`${p}W|** `,...d);break;case $:g(`${p}E|***`,...d);break;default:g(`${p}D|   `,...d);break}}}function Ei(e){return typeof e!="string"?[]:e?.split(`
`).map(t=>{let n=t.match(/^\s+at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/);if(n){let r=n[3]||n[2]||n[4];return r.endsWith(")")&&(r=r.slice(0,-1)),r}})?.filter(Sn)??[]}function dr(e){if(e.includes("/node_modules/"))return "";let t="file://";if(e.startsWith(t))return e.substr(t.length);let n=path.resolve(process.cwd());if(n&&e.startsWith(n))return e.substr(n.length+1);let r=process.env?.HOME?path.resolve(process.env?.HOME):"";return r&&e.startsWith(r)&&(e=`~/${e.substr(r.length+1)}`),e}function Ui(e){let t=e.match(/^\s*at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/);if(t){let n=t[3]||t[2]||t[4];return n.endsWith(")")&&(n=n.slice(0,-1)),n}return ""}function It(e=2,t=!0){let n=new Error("stack").stack||"",r=Ei(n)?.[e];return r&&t&&(r=dr(r)),r||""}function gr(){return new Error("stack").stack||""}function mr(e,t=!0){let n="",r=new Error("stack").stack||"";if(typeof r=="string"){let o=r.split(`
`).map(a=>a.trim()),i=o.findIndex(a=>e.some(s=>a.startsWith(s)));n=o[i+1],n&&(n=Ui(n)),n&&t&&(n=dr(n));}return n}function Fi(){try{return ue(process.env.ZEED_COLOR,Ci__default.default.isatty(process.stdout.fd))}catch{}return !1}var Mt,yr=[6,2,3,4,5,1];function Di(e){let t=0;for(let n=0;n<e.length;n++)t=(t<<5)-t+e.charCodeAt(n),t|=0;return yr[Math.abs(t)%yr.length]}var hr={},Bt;function Ze(...e){process.stdout.write(`${$e(e)}
`);}var be={BOLD:"\x1B[1m",UNBOLD:"\x1B[2m",RED:"\x1B[31m",GREEN:"\x1B[32m",BLUE:"\x1B[34m",PURPLE:"\x1B[35m",GRAY:"\x1B[37m",ORANGE:"\x1B[38;5;208m",UNCOLOR:"\x1B[0m"};var br="\x1B[0m";function xe(e,t){return `${t===8?be.ORANGE:`\x1B[3${t<8?t:`8;5;${t}`}m`}${e}${br}`}function xr(e,t,n=!0){return e.map(r=>{if(typeof r!="string")return r;let o=t,i=br;return n&&(o=`${be.BOLD}${o}`,i=`${i}${be.BOLD}`),`${o}${r}${i}`})}var Si="loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";function wr(e={}){Mt==null&&(Mt=Fi()),Bt==null&&(Bt=K());let{level:t=void 0,filter:n=void 0,colors:r=Mt,levelHelper:o=!0,nameBrackets:i=!0,padding:a=0,fill:s=0,stack:u=!0,time:c=!0}=e,p=j(n),l=z(t);return f=>{if(!l(f.level)||!p(f.name))return;let d=K(),g=f.name||"",m=hr[g||""];m==null&&(m={color:Di(g)},hr[g]=m);let w=At(d-Bt),y,T=i?`[${g}]`:g;if(a>0&&(T=T.padStart(a," ")),s>0&&(T=T.padEnd(s," ")),r){let h=m.color;y=[`${xe(T,h)} | `],f.level===B?y.push(...xr(f.messages,be.ORANGE)):f.level===$?y.push(...xr(f.messages,be.RED)):y.push(...f.messages),c&&y.push(xe(`+${w}`,h));}else y=[T,...f.messages],c&&y.push(`+${w}`);if(f.messages?.[0]===Si&&console.log(gr()),u){let h="";typeof u=="boolean"?(h=mr(["at Function.","at null.log (","at log ("],!0),h||(h=It(0,!0))):h=It(typeof u=="number"?u:3,!0),h&&y.push(xe(`(${h})`,7));}let v="|",C=".";switch(f.level){case O:o&&(y[0]=`I${v}${C}   ${y[0]}`),Ze(...y);break;case B:o&&(y[0]=(r?xe(`W${v}${C}${C}  `,8):`W${v}${C}${C}  `)+y[0]),Ze(...y);break;case $:o&&(y[0]=(r?xe(`E${v}${C}${C}${C} `,1):`E${v}${C}${C}${C} `)+y[0]),Ze(...y);break;default:o&&(y[0]=`D${v}    ${y[0]}`),Ze(...y);break}}}function Pi(e,t){return Qe(n=>{let r=[wr({padding:32,nameBrackets:!1})],o=process.env.ZEED_LOG??process.env.LOG,i=ue(process.env.ZEED_TIME,!0),a=ue(process.env.ZEED_PRETTY,!1);o&&r.unshift(fr(Pt(o),{time:i,pretty:a})),n.setHandlers(r);})(e,t)}

exports.BinaryEncoder = an;
exports.CRYPTO_DEFAULT_ALG = ft;
exports.CRYPTO_DEFAULT_DERIVE_ALG = un;
exports.CRYPTO_DEFAULT_DERIVE_ITERATIONS = zr;
exports.CRYPTO_DEFAULT_HASH_ALG = cn;
exports.Channel = Ct;
exports.CryptoEncoder = Wn;
exports.DAY_MS = bn;
exports.Day = A;
exports.DefaultLogger = R;
exports.Emitter = M;
exports.FileStorage = cr;
exports.JsonEncoder = le;
exports.LocalChannel = ze;
exports.LogLevelAlias = Ot;
exports.LogLevelAll = W;
exports.LogLevelDebug = J;
exports.LogLevelError = $;
exports.LogLevelFatal = Te;
exports.LogLevelInfo = O;
exports.LogLevelOff = ee;
exports.LogLevelWarn = B;
exports.Logger = Pi;
exports.LoggerConsoleHandler = we;
exports.LoggerContext = _t;
exports.LoggerFileHandler = fr;
exports.LoggerMemoryHandler = Vl;
exports.LoggerNodeHandler = wr;
exports.MemStorage = Xn;
exports.NoopEncoder = zn;
exports.Progress = Q;
exports.PubSub = Ft;
exports.SerialQueue = Zn;
exports.Uint8ArrayToDataUri = Ca;
exports.Uint8ArrayToHexDump = qt;
exports.Uint8ArrayToJson = et;
exports.Uint8ArrayToString = Ht;
exports.XRX = _n;
exports._decodeUtf8Polyfill = Sr;
exports._encodeUtf8Polyfill = Dr;
exports._useBase = to;
exports.arrayAvg = Qs;
exports.arrayBatches = Xs;
exports.arrayEmptyInPlace = Gs;
exports.arrayFilterInPlace = mt;
exports.arrayFlatten = ae;
exports.arrayIntersection = Yr;
exports.arrayIsEqual = Xr;
exports.arrayMax = Zs;
exports.arrayMin = Ks;
exports.arrayMinus = Zr;
exports.arrayRandomElement = Js;
exports.arrayRemoveElement = dn;
exports.arraySetElement = Vs;
exports.arrayShuffle = Ws;
exports.arrayShuffleForce = qs;
exports.arrayShuffleInPlace = gn;
exports.arraySorted = Qr;
exports.arraySortedNumbers = zs;
exports.arraySum = Ys;
exports.arraySymmetricDifference = Ns;
exports.arrayToggleInPlace = Hs;
exports.arrayUnion = Kr;
exports.arrayUnique = gt;
exports.assert = Ur;
exports.assertCondition = Nt;
exports.avg = Ps;
exports.between = Ss;
exports.bitfield = ws;
exports.blobToArrayBuffer = Gr;
exports.blobToDataUri = Ua;
exports.blobToUint8Array = Ts;
exports.browserSelectColorByName = Ol;
exports.cloneJsonObject = au;
exports.cloneObject = ce;
exports.cmp = dt;
exports.colorString = xe;
exports.colorStringList = xr;
exports.composeOrderby = Bs;
exports.createArray = ea;
exports.createBinaryStreamDecoder = bs;
exports.createBinaryStreamEncoder = xs;
exports.createLocalChannelPair = Kc;
exports.createPromise = vn;
exports.createPromiseProxy = qn;
exports.csvParse = Fo;
exports.csvParseToObjects = lc;
exports.csvStringify = cc;
exports.dataUriToBlob = Ea;
exports.dataUriToMimeType = va;
exports.dataUriToUint8Array = Aa;
exports.dateStringToDays = Za;
exports.day = Ja;
exports.dayDay = so;
exports.dayDiff = Ma;
exports.dayFromAny = Sa;
exports.dayFromDate = _e;
exports.dayFromDateGMT = Ra;
exports.dayFromParts = Tt;
exports.dayFromString = An;
exports.dayFromTimestamp = ao;
exports.dayFromToday = Ln;
exports.dayIterator = $a;
exports.dayMonth = wn;
exports.dayMonthStart = ka;
exports.dayOffset = Oe;
exports.dayRange = Ba;
exports.dayToDate = Tn;
exports.dayToDateGMT = Pa;
exports.dayToParts = Da;
exports.dayToString = uo;
exports.dayToTimestamp = bt;
exports.dayYear = wt;
exports.dayYearStart = Ia;
exports.debounce = Il;
exports.decimal = co;
exports.decimalCentsPart = Xa;
exports.decimalFromCents = Ya;
exports.decimalToCents = Qa;
exports.decodeBase16 = oa;
exports.decodeBase32 = mn;
exports.decodeBase58 = sa;
exports.decodeBase62 = yn;
exports.decodeJson = hs;
exports.decrypt = pn;
exports.deepEqual = fo;
exports.deepMerge = Ne;
exports.deepStripUndefinedInPlace = po;
exports.deriveKeyPbkdf2 = Es;
exports.detect = Xl;
exports.diffObjects = go;
exports.digest = vs;
exports.duration = Mc;
exports.empty = su;
exports.encodeBase16 = ra;
exports.encodeBase32 = yt;
exports.encodeBase58 = ia;
exports.encodeBase62 = ht;
exports.encodeJson = ys;
exports.encodeQuery = $n;
exports.encrypt = fn;
exports.endSortWeight = Bn;
exports.ensureFolder = vf;
exports.ensureKey = nu;
exports.ensureKeyAsync = ru;
exports.equalBinary = Wt;
exports.escapeHTML = Pn;
exports.escapeRegExp = Ve;
exports.estimateSizeForBase = aa;
exports.exists = kt;
exports.fatal = Er;
exports.fetchBasic = Yn;
exports.fetchJson = ql;
exports.fetchOptionsBasicAuth = qo;
exports.fetchOptionsFormURLEncoded = Zl;
exports.fetchOptionsJson = Kl;
exports.fetchText = Jl;
exports.files = Mf;
exports.filesAsync = Vf;
exports.first = ou;
exports.fixBrokenUth8String = wa;
exports.forEachDay = Wa;
exports.forTimes = lu;
exports.formatMessages = io;
exports.formatMilliseconds = At;
exports.fromBase64 = ve;
exports.fromBase64String = Xi;
exports.fromCamelCase = la;
exports.fromHex = zt;
exports.getEnvVariableRelaxed = xf;
exports.getFingerprint = If;
exports.getFingerprintAsync = Nf;
exports.getGlobal = Ql;
exports.getGlobalContext = X;
exports.getGlobalEmitter = Pc;
exports.getGlobalLogger = Qe;
exports.getGlobalLoggerIfExists = jt;
exports.getNamespaceFilterString = Lr;
exports.getNavigator = Jo;
exports.getPerformanceTimestamp = jn;
exports.getSecureRandom = Wr;
exports.getSecureRandomIfPossible = S;
exports.getSourceLocation = It;
exports.getSourceLocationByPrecedingPattern = mr;
exports.getStack = gr;
exports.getStackLlocationList = Ei;
exports.getStat = nr;
exports.getStatAsync = ir;
exports.getTimestamp = K;
exports.getWebCrypto = gf;
exports.getWindow = Qn;
exports.globToRegExp = Je;
exports.immediate = ja;
exports.isArray = G;
exports.isBoolean = Dn;
exports.isBrowser = Zo;
exports.isEmpty = lo;
exports.isEven = In;
exports.isHalf = ye;
exports.isHiddenPath = qe;
exports.isInteger = gu;
exports.isLocalHost = Bl;
exports.isNotEmpty = bu;
exports.isNotNull = Sn;
exports.isNull = hu;
exports.isNullOrUndefined = yu;
exports.isNumber = Fn;
exports.isObject = N;
exports.isPrime = ks;
exports.isPrimeRX = Rs;
exports.isPrimitive = Lt;
exports.isPromise = I;
exports.isRecord = je;
exports.isRecordPlain = du;
exports.isSafeInteger = mu;
exports.isString = Cn;
exports.isTimeout = Va;
exports.isTruthy = Tu;
exports.isUint8Array = xu;
exports.isValue = wu;
exports.joinToUint8Array = Yi;
exports.jsonStringify = Ji;
exports.jsonStringifySafe = k;
exports.jsonStringifySorted = qi;
exports.jsonToUint8Array = Xe;
exports.last = iu;
exports.lazyListener = Rc;
exports.linkifyPlainText = rc;
exports.listDistinctUnion = Su;
exports.listGroupBy = Du;
exports.listOfKey = Pu;
exports.listQuery = Fu;
exports.loggerStackTraceDebug = Si;
exports.memoize = uu;
exports.memoizeAsync = cu;
exports.moveSortWeight = Yu;
exports.noop = of;
exports.objectIsEmpty = Bu;
exports.objectMap = Iu;
exports.objectMergeDisposable = Mu;
exports.parseArgs = uf;
exports.parseBasicAuth = Wo;
exports.parseDate = Ic;
exports.parseLogLevel = Ke;
exports.parseOrderby = Jr;
exports.parseQuery = oc;
exports.pbcopy = lf;
exports.promisify = H;
exports.qid = Wc;
exports.randomBoolean = Cs;
exports.randomFloat = Ds;
exports.randomInt = Fs;
exports.randomUint8Array = se;
exports.readText = Uf;
exports.regExpEscape = sc;
exports.regExpString = Uo;
exports.removeFolder = Ef;
exports.renderMessages = $e;
exports.roundDown = Vu;
exports.roundHalfAwayFromZero = zu;
exports.roundHalfDown = Wu;
exports.roundHalfEven = qu;
exports.roundHalfOdd = Gu;
exports.roundHalfTowardsZero = Ju;
exports.roundHalfUp = Hu;
exports.roundUp = Nu;
exports.seededRandom = Is;
exports.setUuidDefaultEncoding = Gc;
exports.setupEnv = bf;
exports.setupWebCrypto = df;
exports.size = Un;
exports.sleep = _a;
exports.sortedItems = To;
exports.sortedOrderby = $s;
exports.startSortWeight = Mn;
exports.stringToBoolean = da;
exports.stringToFloat = ma;
exports.stringToInteger = ga;
exports.stringToPath = ti;
exports.stringToUInt8Array = Vt;
exports.suid = Nc;
exports.suidBytes = Vn;
exports.suidBytesDate = No;
exports.suidDate = Vc;
exports.sum = qr;
exports.throttle = kl;
exports.timeout = Na;
exports.toBase64 = fe;
exports.toBase64Url = Qi;
exports.toBool = ba;
exports.toCamelCase = hn;
exports.toCapitalize = no;
exports.toCapitalizeWords = ca;
exports.toFloat = ya;
exports.toHex = Gt;
exports.toHumanReadableFilePath = Af;
exports.toHumanReadableUrl = Ao;
exports.toInt = ha;
exports.toPath = Pt;
exports.toString = xa;
exports.toUint8Array = U;
exports.toValidFilename = kn;
exports.today = qa;
exports.tryTimeout = En;
exports.uname = _;
exports.unescapeHTML = Uu;
exports.useAsyncMutex = vc;
exports.useBase = q;
exports.useDefer = hc;
exports.useDispose = he;
exports.useDisposer = yc;
exports.useEventListener = wc;
exports.useExitHandler = ef;
exports.useInterval = bc;
exports.useLevelFilter = z;
exports.useMessageHub = sl;
exports.useMutex = Ac;
exports.useNamespaceFilter = j;
exports.usePool = El;
exports.usePubSub = pl;
exports.useRPC = gl;
exports.useSorted = ec;
exports.useTimeout = xc;
exports.uuid = Y;
exports.uuid32bit = Hc;
exports.uuidB32 = ko;
exports.uuidB62 = So;
exports.uuidBytes = Et;
exports.uuidDecode = Gn;
exports.uuidDecodeB32 = Mo;
exports.uuidDecodeB62 = Ro;
exports.uuidDecodeV4 = _o;
exports.uuidEncode = Vo;
exports.uuidEncodeB32 = Io;
exports.uuidEncodeB62 = Po;
exports.uuidEncodeV4 = Oo;
exports.uuidIsValid = zc;
exports.uuidv4 = $o;
exports.valueToBoolean = ue;
exports.valueToFloat = oo;
exports.valueToInteger = ro;
exports.valueToPath = ni;
exports.valueToString = xt;
exports.waitOn = Ha;
exports.walkSync = rr;
exports.walkSyncAsync = sr;
exports.writeText = Cf;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=index.node.cjs.map